if (typeof(ConfigureTheme)=="undefined") var ConfigureTheme = (function () {
    // -------------------- shared AO variables
    var DEFAULT_LAYOUT_ID = "DEFAULT";
    var selectedNodeID=DEFAULT_LAYOUT_ID;
    var previousNodeId=DEFAULT_LAYOUT_ID;
    var unsavedChanges=false;
    var managedLayout;// the currently selected theme's data
    var children;// the raw hierarchy data (list of each layout's children keyed by layout id)
    var layoutTree;// the nlstree object
    var layoutTreeDD;// the nlstreedd object
    var borderLayout;// the borderLayout object

    // -------------------- icon control
    var iconPath="/download/resources/com.adaptavist.confluence.themes.sitebuilder:sitebuilder/icons/";
    var iconStyles={readonly:["document_lock.png","document_lock.png"],
                    layout:["document.png","document.png"],
                    unsaved:["document_warning.png","document_warning.png"],
                    newlayout:["document_add.png","document_add.png"]};
    function getIcons(style) {
        if (iconStyles[style]!=null) return contextPath+iconPath+iconStyles[style][0]+","+contextPath+iconPath+iconStyles[style][1];
        return null;
    }


    // -------------------- tab loading
    function loadedTabContent(activeTab) {
        return function (tabcontent) {
            Visibility.removeClass(document.body,"waitCursor");
            Visibility.addClass(document.body,"normalCursor");
            activeTab.setContent(tabcontent,true);
        }
    }
    function loadTabContent(tabPanel, activeTab) {
        if (!activeTab.loaded) {
            activeTab.loaded=true;// dont really want to try and load it twice ;)
            Visibility.removeClass(document.body,"normalCursor");
            Visibility.addClass(document.body,"waitCursor");
            ManageLayoutsDWR.getTab(activeTab.id,loadedTabContent(activeTab));
        }
    }

    // -------------------- layout loading
    function layoutLoaded(data) {
        Visibility.removeClass(document.body,"waitCursor");
        Visibility.addClass(document.body,"normalCursor");
        if (!data.viewPermission) {
            alert("You do not have permission to use this layout");
            loadLayout(null,DEFAULT_LAYOUT_ID);
        }
        managedLayout=data;
        previousNodeId=selectedNodeID;
        selectedNodeID=data.layout.layoutId;
        layoutTree.selectNodeById(selectedNodeID);
        var layoutInp = document.getElementById("layoutId");
        if (layoutInp!=null) {
            layoutInp.value = selectedNodeID;
        }
        if (typeof(DescriptionTab)!="undefined") DescriptionTab.layoutLoaded(data);
        if (typeof(QuickPreviewTab)!="undefined") QuickPreviewTab.layoutLoaded(data);
        if (typeof(FullPreviewTab)!="undefined") FullPreviewTab.layoutLoaded(data);
    }
    function loadLayout(e,treeNodeID) {
        Visibility.removeClass(document.body,"normalCursor");
        Visibility.addClass(document.body,"waitCursor");
        ManageLayoutsDWR.getLayout(treeNodeID,layoutLoaded);
    }

    // -------------------- layout initialisation
    function initBorderLayout() {
        if (borderLayout!=null) return;
        borderLayout = new Ext.BorderLayout("layoutselector", {
            hideOnLayout: true,
            autoCreate: true,
            west: {
                split:true,
                initialSize: 150,
                minSize: 150,
                maxSize: 400,
                titlebar: true,
                collapsible: true,
                animate: true,
                autoCreate: true,
                autoScroll: true
            },
//            south: {
//                split:true,
//                initialSize: 100,
//                minSize: 100,
//                maxSize: 200,
//                titlebar: true,
//                collapsible: true,
//                animate: true,
//                autoCreate: true,
//                autoScroll: false
//            },
            center: {
                titlebar: false,
                tabPosition: 'top',
                autoCreate: true,
                autoScroll: true
            }
        });
        Ext.get("layoutselector").borderLayout=borderLayout;
        // build the layout
        borderLayout.beginUpdate();
//        borderLayout.add('south', new Ext.ContentPanel('helppanel', {title: 'Information', autoScroll: true, closable: true, autoCreate: true}));
        borderLayout.add('west', new Ext.ContentPanel('treepanel', {title: 'Choose layout...', autoScroll: true, autoCreate: true}));
        borderLayout.add('center', new Ext.ContentPanel('descriptionTab', {title: 'Overview', autoScroll: true, autoCreate: true}));
        borderLayout.add('center', new Ext.ContentPanel('quickpreview', {title: 'Quick Preview', autoScroll: true, autoCreate: true}));
        borderLayout.add('center', new Ext.ContentPanel('fullpreview', {title: 'Full Preview', autoScroll: true, autoCreate: true}));
        borderLayout.endUpdate();
        // update the tab-panel AO
        tabPanel = borderLayout.getRegion("center").getTabs();
        tabPanel.addListener("tabchange",loadTabContent);
        tabPanel.activate('descriptionTab');
        // update the tree panel
        Ext.get("treepanel").update("<div id='treeview' class='treeview'></div>");
        initTree();
        borderLayout.layout();
    }
    Ext.EventManager.onDocumentReady(initBorderLayout);


    // -------------------- tree initialisation
    function createBranch (layoutId, data) {
      var branch={};
      if (data[layoutId]!=null) {
        var o = data[layoutId].reverse();
        var i = o.length;
        while (-1<--i) {
          branch[o[i]] = createBranch(o[i],data);
        }
      }
      return branch;
    }
    function generateChildNodes(parentNodeId,childNodeData){
        var i;
        for (i in childNodeData) {
            layoutTree.add(i,parentNodeId,i,"",getIcons("layout"),true,false,{id:i},"description");
            generateChildNodes(i,childNodeData[i]);
        }
    }
    var onNodeDrop;
    function treeInit(data) {
        children=data;
        Visibility.removeClass(document.body,"waitCursor");
        Visibility.addClass(document.body,"normalCursor");
        layoutTree=new NlsTree("layoutTree");
        layoutTree.treeOnClick=loadLayout;
        layoutTree.add(DEFAULT_LAYOUT_ID, 0, DEFAULT_LAYOUT_ID, "", getIcons("readonly"), true, false, {id:"DEFAULT"}, "Default layout (read only)");
        generateChildNodes(DEFAULT_LAYOUT_ID,createBranch(DEFAULT_LAYOUT_ID,data));
        layoutTree.render("treeview");
        loadLayout(null,(LAYOUT_ID!=null && LAYOUT_ID.length>0) ? LAYOUT_ID : DEFAULT_LAYOUT_ID);
    }
    var tree_timeout = 0;
    function initTree() {
        if (typeof(dwr.engine)!="undefined" && typeof(ManageLayoutsDWR)!="undefined" && typeof(NlsTree)!="undefined") {
            Visibility.removeClass(document.body,"normalCursor");
            Visibility.addClass(document.body,"waitCursor");
            ManageLayoutsDWR.getHierarchy(treeInit);
        } else {
            if (tree_timeout++ < 120) {
                setTimeout(initTree, 250);
            } else {
                alert("configuretheme.js : failed tree initialisation");
            }
        }
    }

    // -------------------- go to previous layout
    function prevLayout() {
        var siblings=children[managedLayout.layout.parentId];
        var i=siblings.length;
        while (-1<--i) if (siblings[i]==managedLayout.layout.layoutId) break;
        if (++i>=siblings.length) i=0;
        loadLayout(null,siblings[i]);
    }

    // -------------------- go to parent layout
    function parentLayout() {
        if (themeData.parentId!=null) loadLayout(null,managedLayout.layout.parentId);
    }

    // -------------------- go to next layout
    function nextLayout() {
        var siblings=children[managedLayout.layout.parentId];
        var i=siblings.length;
        while (-1<--i) if (siblings[i]==managedLayout.layout.layoutId) break;
        if (--i<0) i=siblings.length-1;
        loadLayout(null,siblings[i]);
    }

    // -------------------- switch to the last used layout
    function switchLayouts() {
        loadLayout(null,previousNodeId);
    }

    // -------------------- return 'public' api
    return {getManagedLayout:function(){return managedLayout;},
        prevLayout:prevLayout,
        parentLayout:parentLayout,
        nextLayout:nextLayout,
        switchLayouts:switchLayouts};
})();

var LayoutTab={editPanel:function(){}};