if (typeof(GroupSelector)=="undefined") var GroupSelector = (function () {
    var groupDialog;
    var current;

    // tab loading
    function loadedTabContent(activeTab) {
        return function (tabcontent) {
            Visibility.removeClass(document.body,"waitCursor");
            Visibility.addClass(document.body,"normalCursor");
            activeTab.setContent(tabcontent,true);
            updateSelection();
        }
    }
    function loadTabContent(tabPanel, activeTab) {
        if (!activeTab.loaded) {
            activeTab.loaded=true;// dont really want to try and load it twice ;)
            Visibility.removeClass(document.body,"normalCursor");
            Visibility.addClass(document.body,"waitCursor");
            GroupSelectorDWR.getTab(activeTab.id,loadedTabContent(activeTab));
        }
    }

    function applySelection() {
        var groupSelect = document.getElementById("groupselector-grouplist");
        var selected = [];
        if (groupSelect!=null) {
            var options = groupSelect.options;
            var i = options.length;
            while (-1<--i) if (options[i].selected) selected.push(options[i].value);
        }
        current.callback(current.target,selected);
        groupDialog.hide();
    }
    function updateSelection() {
        var groupSelect = document.getElementById("groupselector-grouplist");
        if (groupSelect!=null) {
            groupSelect.multiple = (current.multi==true);
            if (current.selected) {
                var selected = current.selected;
                var options = groupSelect.options;
                var i = options.length;
                while (-1<--i) options[i].selected=(selected[options[i].value]==true);
            }
        }
    }

    function show(o){
        if (o==null || typeof("o.target")=="undefined" || typeof("o.callback")=="undefined") return;
        if (groupDialog==null) {
            groupDialog = new Ext.LayoutDialog("selectGroup-dlg", {
                modal:false,
                width:300,
                height:200,
                shadow:true,
                minWidth:300,
                minHeight:200,
                autoCreate:true,
                constraintoviewport:false,
                center:{
                    tabPosition:"top",
                    alwaysShowTabs:true,
                    autoCreate:true
                }});
            var layout = groupDialog.getLayout();
            layout.beginUpdate();
            layout.add('center', new Ext.ContentPanel('groupSelector', {title: 'Groups', autoScroll: true, autoCreate: true}));
//            layout.add('center', new Ext.ContentPanel('userSelector', {title: 'Users', autoScroll: true, autoCreate: true}));
            layout.endUpdate();
            var tabPanel = layout.getRegion("center").getTabs();
//            tabPanel.addListener("tabchange",loadTabContent);
//            tabPanel.activate("layoutEdit-content");
            loadTabContent(null,tabPanel.getTab("groupSelector"));
            groupDialog.addButton('OK', applySelection);//.disable();
            groupDialog.addButton('Cancel', groupDialog.hide, groupDialog);
//            groupDialog.addKeyListener(27, applyPanel);
        } else if (current!=null) {
            groupDialog.hide(current.target);
        }
        current=o;
        updateSelection();
        groupDialog.show();
    }
    return{show:show};
})();