if (typeof(ColourDialog)=="undefined") var ColourDialog = (function () {
    var currentcolour;
    var confColours = LayoutTab.getConfColours();
    var confColourNames = LayoutTab.getConfColourNames();

    function selectColour(colour,source) {
        var updateHistory=!(colour==currentcolour || colour==getSelectedColourValue());
        currentcolour=colour;
        // update ourself
        var currentswatch = document.getElementById("currentswatch");
        if (currentswatch!=null) {
            currentswatch.style.backgroundColor=getSelectedColourValue();
        }
        var currentvalue = document.getElementById("currentvalue");
        if (currentvalue!=null) {
            currentvalue.value = getSelectedColourName();
        }
        // update the other panels (if loaded)
        if (source!="BuilderColours" && typeof(BuilderColours)!="undefined") {
            BuilderColours.selectColour(getSelectedColourValue())
        }
        if (source!="Palette" && typeof(Palette)!="undefined") {
            Palette.selectColour(getSelectedColourValue());
        }
        if (source!="ColorPicker" && typeof(YAHOO)!="undefined" && typeof(YAHOO.example.ColorPicker)!="undefined") {
            YAHOO.example.ColorPicker.selectColour(getSelectedColourValue());
        }
        if (updateHistory && source!="ColourHistory" && typeof(ColourHistory)!="undefined") {
            ColourHistory.selectColour(colour);
        }
        if (typeof(ColourContrast)!="undefined") {
            ColourContrast.selectColour(getSelectedColourValue());
        }
    }

    function getSelectedColour() {
        return currentcolour;
    }

    function getSelectedColourValue() {
        if (confColours[currentcolour]!=null) {
            return confColours[currentcolour];
        }
        return currentcolour;
    }

    function getSelectedColourName() {
        if (confColourNames[currentcolour]!=null) {
            return confColourNames[currentcolour];
        }
        return currentcolour;
    }

    function updateDisplay() {
        var display=document.getElementById("colourpicker-colour");
        if (display!=null) {
            var output="<table><tr><td width='188px' valign='top'><table><tr>";
            var i;
            var c=0;
            var name;
            for (id in confColourNames) {
                if ((c++)%3==0) output+="</tr><tr>";
                output+="<td style='background-color:"+confColours[id]+";width:50px;height:30px;cursor:pointer;border:1px solid grey;'><div onclick='ColourDialog.selectColour(\""+id+"\",\"ColourDialog\");' title='Confluence colour: "+confColourNames[id]+"'>&nbsp;</div></td>";
            }
            output+="</tr></table></td><td align='center' valign='middle'><div class='colourpicker-label'>Current Selection</div><div id='currentswatch' style='width:90px;height:90px;border:2px solid #aaaaaa;margin:10px'>&nbsp;</div><input type='text' id='currentvalue'><input type='button' onclick='ColourDialog.useCurrent()' value='Set'></td>";
            output+="</tr><tr></table>";
            display.innerHTML=output;
        }
    }

    function useCurrent() {
        var currentvalue = document.getElementById("currentvalue");
        if (currentvalue!=null) {
            selectColour(currentvalue.value,"ColourDialog");
        }
    }

    function init() {
        updateDisplay();
        if (PanelEditor.getCurrentColour()!=null) {
            selectColour(PanelEditor.getCurrentColour())
        } else {
            selectColour("#99FF77");
        }
    }
    return {selectColour:selectColour,
        getSelectedColour:getSelectedColour,
        getSelectedColourValue:getSelectedColourValue,
        useCurrent:useCurrent,
        init:init};
})();
