if (typeof(ColourHistory)=="undefined") var ColourHistory = (function () {
    var history=[];
    var confColours = LayoutTab.getConfColours();
    var confColourNames = LayoutTab.getConfColourNames();

    function getColourValue(colour) {
        if (confColours[colour]!=null) {
            return confColours[colour];
        }
        return colour;
    }

    function getColourName(colour) {
        if (confColourNames[colour]!=null) {
            return confColourNames[colour];
        }
        return colour;
    }

    function updateDisplay() {
        var display=document.getElementById("colour-history");
        if (display!=null) {
            var output="<table><tr>";
            var i= history.length;
            while (-1<--i) output+="<td><div style='width:20px;height:20px;background-color:"+getColourValue(history[i])+";cursor:pointer;' onclick='ColourDialog.selectColour(\""+history[i]+"\",\"ColourHistory\")' title='Colour : "+getColourName(history[i])+"'>&nbsp;&nbsp;&nbsp;</div></td>";
            output+="</tr></table>";
            display.innerHTML=output;
        }
    }

    var timeoutId;
    function update() {
        clearTimeout(timeoutId);
        timeoutId=setTimeout(updateDisplay,555);
    }

    function selectColour(colour) {
        history.push(colour);
        update();
    }


    return {selectColour:selectColour};
})();
