if (typeof(ColourContrast)=="undefined") var ColourContrast = (function () {
    var SQUARE_SIZE=20;
    var CELLCHARS="&nbsp;&nbsp;&nbsp;"

    function RGB2HSB(RGBstr){
        var red = parseInt(RGBstr.substr(1,2),16);
        var gre = parseInt(RGBstr.substr(3,2),16);
        var blu = parseInt(RGBstr.substr(5,2),16);
        if ((red==NaN) || (gre==NaN) || (blu==NaN)) return -1;
        var max = Math.max(red,Math.max(gre,blu));
        var min = Math.min(red,Math.min(gre,blu));
        var colHSB = {H:0,S:0,B:Math.round(max*100/255)};
        if(max!=min){
            colHSB.S = Math.round(100*(max-min)/max);
            var hue;
            var tmpR = (max-red)/(max-min);
            var tmpG = (max-gre)/(max-min);
            var tmpB = (max-blu)/(max-min);
            if(red==max){
                hue = tmpB - tmpG;
            }else if(gre==max){
                hue = 2 + tmpR - tmpB;
            }else if(blu==max){
                hue = 4 + tmpG - tmpR;
            }
            colHSB.H = (Math.round(hue*60) + 360)%360;
        }
        return colHSB;
    }
    function XX(s) {
        while (s.length<2) s="0"+s;
        return s;
    }
    function HSB2RGB(hue,sat,bri){
        var red, green, blue;
        sat=sat%101;
        bri=bri%101;
        if(sat==0){
            red = bri;
            green = bri;
            blue = bri;
        }else{
            hue = (hue+360)%360;
            var hue2 = Math.floor(hue/60);
            var dif = (hue/60)-hue2;
            sat/=100;
            bri/=100;
            var mid1 = bri*(1-sat*dif);
            var mid2 = bri*(1-sat*(1-dif));
            var min = bri*(1-sat);
            if(hue2 == 0){
                red = bri;
                green= mid2;
                blue = min;
            } else if(hue2 == 1) {
                red = mid1;
                green = bri;
                blue = min;
            } else if(hue2 == 2) {
                red = min;
                green = bri;
                blue = mid2;
            } else if(hue2 == 3) {
                red = min;
                green = mid1;
                blue = bri;
            } else if(hue2 == 4) {
                red = mid2;
                green = min;
                blue = bri;
            } else {
                red = bri;
                green = min;
                blue = mid1;
            }
        }
        red = (red==NaN) ? 0 : Math.min(Math.round(red*255),255);
        green = (green==NaN) ? 0 : Math.min(Math.round(green*255),255);
        blue = (blue==NaN) ? 0 : Math.min(Math.round(blue*255),255);
        return "#"+XX(red.toString(16))+XX(green.toString(16))+XX(blue.toString(16));
    }

    function generateCell(colour,title,style,id,call) {
        return "<td id='"+id+"' style='background:"+colour+";width:"+SQUARE_SIZE+"px;height:"+SQUARE_SIZE+"px;'><div style='width:"+SQUARE_SIZE+"px;height:"+SQUARE_SIZE+"px;overflow:hidden;cursor:pointer;"+style+"' onclick='"+call+"' title='"+title+"'>"+CELLCHARS+"</div></td>";
    }

    function limit(x, l) {
        return Math.min(l,(x<0) ? 0 : x);
    }

    var LTB1="border-left:1px solid #5A6B7D;border-bottom:1px solid #5A6B7D;border-top:1px solid #5A6B7D;overflow:hidden;";
    var TB1="border-bottom:1px solid #5A6B7D;border-top:1px solid #5A6B7D;overflow:hidden;";
    var RTB1="border-right:1px solid #5A6B7D;border-bottom:1px solid #5A6B7D;border-top:1px solid #5A6B7D;overflow:hidden;"

    LTB1=TB1=RTB1="border:1px inset #5A6B7D;border-top:1px solid #5A6B7D;overflow:hidden;";

    function modulate(colour,shortSpan) {
        var html = generateCell(colour,"Colour : "+colour,LTB1,"S"+colour,"ColourDialog.selectColour(\""+colour+"\",\"ColourContrast\");");// #1
        var orig=RGB2HSB(colour);
        var comp={H:orig.H,S:orig.S};
        var comp2={};
        var comp3={};
        if (orig.B > 70) {
          comp.B=orig.B-30;
            colour=HSB2RGB(orig.H,orig.S,orig.B-15);
            html += generateCell(colour,"Colour : "+colour,TB1,"S"+colour,"ColourDialog.selectColour(\""+colour+"\",\"ColourContrast\");");// #2
        } else {
          comp.B=orig.B+30;
            colour=HSB2RGB(orig.H,orig.S,orig.B+15);
            html += generateCell(colour,"Colour : "+colour,TB1,"S"+colour,"ColourDialog.selectColour(\""+colour+"\",\"ColourContrast\");");// #2
        }
        colour=HSB2RGB(comp.H,comp.S,comp.B);
        html += generateCell(colour,"Colour : "+colour,((shortSpan==true) ? RTB1 : TB1),"S"+colour,"ColourDialog.selectColour(\""+colour+"\",\"ColourContrast\");");// #3
        if (orig.H<30) {
            comp  = {H:orig.H+20, S:orig.S, B:orig.B};
            comp2 = {H:orig.H+20, S:orig.S};
            comp3 = {H:orig.H+20, S:orig.S};
            if (orig.B > 70) {
                comp2.B=orig.B-30;
                comp3.B=orig.B-15;
            } else {
                comp2.B=orig.B+30;
                comp3.B=orig.B+15;
            }
        } else if (orig.H<60) {
            comp  = {H:orig.H+150, S:limit(orig.S-30,100), B:limit(orig.B-20,100)};
            comp2 = {H:orig.H+150, S:limit(orig.S-70,100), B:limit(orig.B+20,100)};
            comp3 = {H:orig.H+150, S:limit(orig.S-70,100), B:orig.B};
        } else if (orig.H<180) {
            comp  = {H:orig.H-40, S:orig.S, B:orig.B};
            comp2 = {H:orig.H-40, S:orig.S};
            comp3 = {H:orig.H-40, S:orig.S};
            if (orig.B > 70) {
                comp2.B=orig.B-30;
                comp3.B=orig.B-15;
            } else {
                comp2.B=orig.B+30;
                comp3.B=orig.B+15;
            }
        } else if (orig.H<220) {
            comp  = {H:orig.H-160, S:orig.S, B:orig.B};
            comp2 = {H:orig.H-170, S:orig.S};
            comp3 = {H:orig.H-170, S:orig.S};
            if (orig.B > 70) {
                comp2.B=orig.B-30;
                comp3.B=orig.B-15;
            } else {
                comp2.B=orig.B+30;
                comp3.B=orig.B+15;
            }
        } else if (orig.H<300) {
            comp  = {H:orig.H, S:limit(orig.S - 60 ,100), B:orig.B};
            comp2 = {H:orig.H, S:limit(orig.S - 60 ,100)};
            comp3 = {H:orig.H, S:limit(orig.S - 60 ,100)};
            if (orig.B > 70) {
                comp2.B=orig.B-30;
                comp3.B=orig.B-15;
            } else {
                comp2.B=orig.B+30;
                comp3.B=orig.B+15;
            }
        } else {
            comp  = {H:orig.H+20, B:orig.B};
            comp2 = {H:orig.H+20};
            comp3 = {H:orig.H+20};
            if (orig.S > 50) {
                comp3.S=comp2.S=comp.S=orig.S-40;
            } else {
                comp3.S=comp2.S=comp.S=orig.S+40;
            }
            if (orig.B > 70) {
                comp2.B=orig.B-30;
                comp3.B=orig.B-15;
            } else {
                comp2.B=orig.B+30;
                comp3.B=orig.B+15;
            }
        }
        colour=HSB2RGB(comp.H,1+comp.S,comp.B);
        html += generateCell(colour,"Colour : "+colour,TB1,"S"+colour,"ColourDialog.selectColour(\""+colour+"\",\"ColourContrast\");");// #4
        colour=HSB2RGB(comp3.H,1+comp3.S,comp3.B);
        html += generateCell(colour,"Colour : "+colour,TB1,"S"+colour,"ColourDialog.selectColour(\""+colour+"\",\"ColourContrast\");");// #5
        colour=HSB2RGB(comp2.H,1+comp2.S,comp2.B);
        html += generateCell(colour,"Colour : "+colour,RTB1,"S"+colour,"ColourDialog.selectColour(\""+colour+"\",\"ColourContrast\");");// #6
        return html;
    }

    function generateSample(colour) {
//        return "&nbsp;<span onclick='ColourDialog.selectColour(\""+colour+"\",\"ColourContrast\");' title='Colour : "+colour+"' style='cursor:pointer;border:2px solid "+colour+";background:"+colour+"'>"+CELLCHARS+"</span>";
        return generateCell(colour,"Colour : "+colour,TB1,"S"+colour,"ColourDialog.selectColour(\""+colour+"\",\"ColourContrast\");");// #2
    }
    function generatePreview(colour) {
        var orig = RGB2HSB(colour);
        var contrast=180 + orig.H;
        var html="<table><tr>";
        html+=generateSample(HSB2RGB(orig.H, 96, orig.B));
        html+=generateSample(HSB2RGB(orig.H, 80, orig.B));
        html+=generateSample(HSB2RGB(orig.H, 64, orig.B));
        html+=generateSample(HSB2RGB(orig.H, 48, orig.B));
        html+=generateSample(HSB2RGB(orig.H, 32, orig.B));
        html+=generateSample(HSB2RGB(orig.H, 16, orig.B));
        html+="<td>&nbsp;</td>";
        html+=generateSample(HSB2RGB(contrast, 96, orig.B));
        html+=generateSample(HSB2RGB(contrast, 80, orig.B));
        html+=generateSample(HSB2RGB(contrast, 64, orig.B));
        html+=generateSample(HSB2RGB(contrast, 48, orig.B));
        html+=generateSample(HSB2RGB(contrast, 32, orig.B));
        html+=generateSample(HSB2RGB(contrast, 16, orig.B));
        html+="</tr><tr>";
        html+=generateSample(HSB2RGB(orig.H, orig.S, 16));
        html+=generateSample(HSB2RGB(orig.H, orig.S, 32));
        html+=generateSample(HSB2RGB(orig.H, orig.S, 48));
        html+=generateSample(HSB2RGB(orig.H, orig.S, 64));
        html+=generateSample(HSB2RGB(orig.H, orig.S, 80));
        html+=generateSample(HSB2RGB(orig.H, orig.S, 96));
        html+="<td>&nbsp;</td>";
        html+=generateSample(HSB2RGB(contrast, orig.S, 16));
        html+=generateSample(HSB2RGB(contrast, orig.S, 32));
        html+=generateSample(HSB2RGB(contrast, orig.S, 48));
        html+=generateSample(HSB2RGB(contrast, orig.S, 64));
        html+=generateSample(HSB2RGB(contrast, orig.S, 80));
        html+=generateSample(HSB2RGB(contrast, orig.S, 96));
        html+="</tr><tr>";
        // original
        html+=modulate(colour);
        html+="<td>&nbsp;</td>";
        html+=modulate(HSB2RGB(180 + orig.H, orig.S,orig.B));
        html+="</tr><tr>";
        // 30 degrees
        html+=modulate(HSB2RGB(30  + orig.H, orig.S,orig.B));
        html+="<td>&nbsp;</td>";
        html+=modulate(HSB2RGB(210 + orig.H, orig.S,orig.B));
        html+="</tr><tr>";
        // 60
        html+=modulate(HSB2RGB(60  + orig.H, orig.S,orig.B));
        html+="<td>&nbsp;</td>";
        html+=modulate(HSB2RGB(240 + orig.H, orig.S,orig.B));
        html+="</tr><tr>";
        // 90
        html+=modulate(HSB2RGB(90  + orig.H, orig.S,orig.B));
        html+="<td>&nbsp;</td>";
        html+=modulate(HSB2RGB(270 + orig.H, orig.S,orig.B));
        html+="</tr><tr>";
        // 120
        html+=modulate(HSB2RGB(120 + orig.H, orig.S,orig.B));
        html+="<td>&nbsp;</td>";
        html+=modulate(HSB2RGB(300 + orig.H, orig.S,orig.B));
//        html+="</tr><tr>";
        // 150
//        html+=modulate(HSB2RGB(150 + orig.H, orig.S,orig.B));
//        html+="<td>&nbsp;</td>";
//        html+=modulate(HSB2RGB(330 + orig.H, orig.S,orig.B));
        html+="</tr></table>";
        return html;
    }


    function selectColour(colour) {
        var display = document.getElementById("colourpicker-contrast");
        if (display!=null) {
            display.innerHTML=generatePreview(colour);
        }
    }
    selectColour(ColourDialog.getSelectedColourValue());

    return {selectColour:selectColour};
})();