if (typeof(CssTab)=="undefined") var CssTab = (function () {
    var editDialog;
    var layout;

    // -------------------- standard input utility functions
    function disableProp(prop,value) {
        var inp=document.getElementById("cssTab."+prop);
        if (inp!=null) inp.readOnly=value;
    }
    function disableCheckbox(prop,value) {
        var inp=document.getElementById("cssTab."+prop);
        if (inp!=null) inp.disabled=value;
    }
    function disableSelect(prop,value) {
        var inp=document.getElementById("cssTab."+prop);
        if (inp!=null) inp.disabled=value;
    }

    function setProp(prop,value) {
        var inp=document.getElementById("cssTab."+prop);
        if (inp!=null) inp.value=value;
    }
    function setCheckbox(prop,value) {
        var inp=document.getElementById("cssTab."+prop);
        if (inp!=null) inp.checked=value;
    }
    function setSelect(prop,value) {
        var inp=document.getElementById("cssTab."+prop);
        if (inp!=null) {
            var i=inp.options.length;
            while (-1<--i) if ((""+inp.options[i].value)==value) inp.selectedIndex=i;
        }
    }
    function updateDisplay(managedLayout) {
        if (managedLayout==null) return;
        layout = managedLayout.layout;
        setProp("customCSS",layout.customCSS);
        setProp("ieCSS",layout.ieCSS);
        setProp("ieCSSconditional",layout.ieCSSconditional);
        setProp("importCSS",layout.importCSS);
        setCheckbox("mergeCSS",layout.mergeCSS);
        setCheckbox("usePanelCSS",layout.usePanelCSS);
        setCheckbox("useInbuiltCSS",layout.useInbuiltCSS);
        setCheckbox("useAtlassianCSS",layout.useAtlassianCSS);
        setCheckbox("useTabCSS",layout.useTabCSS);
        var disabled=!ManageLayouts.hasLayoutPermission(ManageLayouts.EDIT_PERMISSION);
        var editcss=!(ManageLayouts.hasLayoutPermission(ManageLayouts.EDIT_PERMISSION) && ManageLayouts.hasGlobalPermission(ManageLayouts.EDIT_CSS));
        var advancedcss=!(ManageLayouts.hasLayoutPermission(ManageLayouts.EDIT_PERMISSION) && ManageLayouts.hasGlobalPermission(ManageLayouts.EDIT_ADVANCED) && ManageLayouts.hasGlobalPermission(ManageLayouts.EDIT_CSS));
        disableCheckbox("customCSS", editcss);
        disableCheckbox("ieCSS", editcss);
        disableCheckbox("ieCSSconditional", advancedcss);
        disableCheckbox("importCSS", editcss);
        disableCheckbox("customCSSbtn", editcss);
        disableCheckbox("ieCSSbtn", editcss);
        disableCheckbox("importCSSbtn", editcss);
        disableCheckbox("mergeCSS", editcss);
        disableCheckbox("usePanelCSS", editcss);
        disableCheckbox("useInbuiltCSS", editcss);
        disableCheckbox("useAtlassianCSS", editcss);
        disableCheckbox("useTabCSS", editcss);
    }

    function getProp(prop) {
        var inp=document.getElementById("cssTab."+prop);
        if (inp!=null) return inp.value;
        return null;
    }
    function getCheckbox(prop) {
        var inp=document.getElementById("cssTab."+prop);
        if (inp!=null) return inp.checked;
        return null;
    }
    function getSelect(prop) {
        var inp=document.getElementById("cssTab."+prop);
        if (inp!=null) return inp.options[inp.selectedIndex].value
        return null;
    }
    function getCSSprop(prop, existing) {
        var inp=document.getElementById("cssTab."+prop);
        if (inp!=null) {
            var value=getProp(prop);
            if (value==null || value.length==0) {
                value = "/* empty */";
            }
            return value;
        }
        return existing;
    }
    function updateSettings(layout) {
        layout.customCSS=getCSSprop("customCSS",layout.customCSS);
        layout.ieCSS=getCSSprop("ieCSS",layout.ieCSS);
        layout.ieCSSconditional=getProp("ieCSSconditional",layout.ieCSSconditional);
        layout.importCSS=getCSSprop("importCSS",layout.importCSS);
        layout.mergeCSS=getCheckbox("mergeCSS");
        layout.usePanelCSS=getCheckbox("usePanelCSS");
        layout.useInbuiltCSS=getCheckbox("useInbuiltCSS");
        layout.useAtlassianCSS=getCheckbox("useAtlassianCSS");
        layout.useTabCSS=getCheckbox("useTabCSS");
        return layout;
    }

    function genTab(tab){
        return "<table class=\"layoutParameter-table\" style=\"width:98%;height:98%\">"+
                    "<tbody>"+
                        "<tr class=\"layoutParameter-row\"\">"+
                            "<td class=\"layoutParameter-property\">"+
                                "<div class=\"layoutParameter-section\">"+
                                    "<div class=\"layoutParameter-title\">"+tab+"</div>"+
                                    "<textarea class=\"layoutParameter-property\" id=\"cssTab."+tab+"\" rows=\"21\" style=\"width:100%;height:100%;\" onchange=\"ManageLayouts.changed(true);\">"+
                                        ((layout!=null) ? layout[tab] : "")+
                                    "</textarea>"+
                                "</div>"+
                            "</td>"+
                        "</tr>"+
                    "</tbody>"+
                "</table>";
    }

    function applyDialogSelection() {
        editDialog.hide();
    }

    function cancelDialogSelection() {
        updateDisplay(ManageLayouts.getManagedLayout());
        editDialog.hide();
    }

   function resizeTextBox (){
       var w=editDialog.size.width-44;
       var h=editDialog.size.height-144;
       Ext.get("cssTab.customCSS").setSize(w,h);
       Ext.get("cssTab.ieCSS").setSize(w,h);
   };

    function editContent(tab) {
        if (editDialog==null) {
            editDialog = new Ext.LayoutDialog("cssEdit-dlg", {
                modal:false,
                width:700,
                height:500,
                shadow:true,
                minWidth:300,
                minHeight:300,
                autoCreate:true,
                constraintoviewport:false,
                center:{
                    tabPosition:"top",
                    alwaysShowTabs:true,
                    autoCreate:true
                }});
            var editLayout = editDialog.getLayout();
            editLayout.beginUpdate();
            editLayout.add('center', new Ext.ContentPanel('cssTab-customCSS', {title: 'Custom CSS', autoScroll: true, autoCreate: true}));
            editLayout.add('center', new Ext.ContentPanel('cssTab-ieCSS', {title: 'IE CSS', autoScroll: true, autoCreate: true}));
            editLayout.add('center', new Ext.ContentPanel('cssTab-importCSS', {title: 'Import', autoScroll: true, autoCreate: true}));
            editLayout.endUpdate();
            var tabPanel = editLayout.getRegion("center").getTabs();
            tabPanel.getTab("cssTab-customCSS").setContent(genTab("customCSS"));
            tabPanel.getTab("cssTab-ieCSS").setContent(genTab("ieCSS"));
            tabPanel.getTab("cssTab-importCSS").setContent(genTab("importCSS"));
            editDialog.addButton('OK', applyDialogSelection);
            editDialog.addButton('Cancel', cancelDialogSelection);
            editDialog.addListener("resize",resizeTextBox);
            updateDisplay(ManageLayouts.getManagedLayout());
        }
        editDialog.getLayout().getRegion("center").getTabs().activate("cssTab-"+tab);
        editDialog.show();
    }

    function clearValue(prop) {
        if ((ManageLayouts.hasLayoutPermission(ManageLayouts.EDIT_PERMISSION) && ManageLayouts.hasGlobalPermission(ManageLayouts.EDIT_ADVANCED))) {
            ManageLayouts.clearValue(prop);
        }
    }

//    var active=true;
//    function setActive(tabPanel, activeTab) {
//        active = (activeTab.id=="cssTab");
//        if (active) updateDisplay(ManageLayouts.getManagedLayout());
//    }
//    Ext.get("layoutmanager").borderLayout.getRegion("center").getTabs().addListener("tabchange",setActive);
    function layoutLoaded(managedLayout) {
//        if (active) updateDisplay(managedLayout);
        updateDisplay(managedLayout);
    }
    updateDisplay(ManageLayouts.getManagedLayout());

    return {updateSettings:updateSettings,
        updateDisplay:updateDisplay,
        layoutLoaded:layoutLoaded,
        clearValue:clearValue,
        editContent:editContent};
})();

