if (typeof(DescriptionTab)=="undefined") var DescriptionTab = (function () {
    // -------------------- standard input utility functions
    function disableProp(prop,value) {
        var inp=document.getElementById("descriptionTab."+prop);
        if (inp!=null) inp.readOnly=value;
    }
    function disableCheckbox(prop,value) {
        var inp=document.getElementById("descriptionTab."+prop);
        if (inp!=null) inp.disabled=value;
    }
    function disableSelect(prop,value) {
        var inp=document.getElementById("descriptionTab."+prop);
        if (inp!=null) inp.disabled=value;
    }

    function setDiv(prop,value) {
        var inp=document.getElementById("descriptionTab."+prop);
        if (inp!=null) inp.innerHTML=value;
    }
    function setProp(prop,value) {
        var inp=document.getElementById("descriptionTab."+prop);
        if (inp!=null) inp.value=value;
    }
    function setCheckbox(prop,value) {
        var inp=document.getElementById("descriptionTab."+prop);
        if (inp!=null) inp.checked=value;
    }
    function setSelect(prop,value) {
        var inp=document.getElementById("descriptionTab."+prop);
        if (inp!=null) {
            var i=inp.options.length;
            while (-1<--i) if ((""+inp.options[i].value)==value) inp.selectedIndex=i;
        }
    }
    function updateDisplay(managedLayout) {
        if (managedLayout==null) return;
        var layout = managedLayout.layout;
        setDiv("layoutId", layout.layoutId + ((managedLayout.editPermission) ? "" : " (Read Only)"));
        setDiv("parentId", layout.parentId);
        setProp("name", layout.name);
        setProp("description", layout.description);
//        var disabled=!ManageLayouts.hasLayoutPermission(ManageLayouts.EDIT_PERMISSION);
        var disabled=!managedLayout.editPermission;// do it directly since this tab is used in two places
//        disableProp("layoutId", disabled);// cant be edited anyway
//        disableProp("parentId", disabled);// cant be edited anyway
        disableProp("name", disabled);
        disableProp("description", disabled);
    }

    function getProp(prop) {
        var inp=document.getElementById("descriptionTab."+prop);
        if (inp!=null) return inp.value;
        return null;
    }
    function getCheckbox(prop) {
        var inp=document.getElementById("descriptionTab."+prop);
        if (inp!=null) return inp.checked;
        return null;
    }
    function getSelect(prop) {
        var inp=document.getElementById("descriptionTab."+prop);
        if (inp!=null) return inp.options[inp.selectedIndex].value
        return null;
    }
    function updateSettings(layout) {
//        settings.layoutId=getProp("layoutId");// cant be edited
//        settings.parentId=getProp("parentId");// cant be edited
        layout.name=getProp("name");
        layout.description=getProp("description");
        return layout;
    }

//    var active=true;
    function getManagedLayout() {
        if (typeof(ManageLayouts)!="undefined") return ManageLayouts.getManagedLayout();
        if (typeof(ConfigureTheme)!="undefined") return ConfigureTheme.getManagedLayout();
        return null;
    }
//    function setActive(tabPanel, activeTab) {
//        active = (activeTab.id=="descriptionTab");
//        if (active) updateDisplay(getManagedLayout());
//    }
//    var bl=Ext.get("layoutmanager");
//    if (bl==null) bl=Ext.get("layoutselector");
//    if (bl!=null) bl.borderLayout.getRegion("center").getTabs().addListener("tabchange",setActive);
    function layoutLoaded(managedLayout) {
//        if (active) updateDisplay(managedLayout);
        updateDisplay(managedLayout);
    }
    updateDisplay(getManagedLayout());

    return {updateSettings:updateSettings, updateDisplay:updateDisplay, layoutLoaded:layoutLoaded};
})();

