if (typeof(PanelEditor)=="undefined") var PanelEditor = (function () {
    DynarchMenu.setup("panelmenu", {electric:true, tooltips:true, lazy:true});

    var pickerTarget;
    var pickerDialog;

    // tab loading
    function loadedTabContent(activeTab) {
        return function (tabcontent) {
            Visibility.removeClass(document.body,"waitCursor");
            Visibility.addClass(document.body,"normalCursor");
            if (typeof(activeTab.setContent)!="undefined") {
                activeTab.setContent(tabcontent,true);
            } else {
                activeTab.update(tabcontent,true);
            }
        }
    }
    function loadTabContent(tabPanel, activeTab) {
        if (!activeTab.loaded) {
            activeTab.loaded=true;// dont really want to try and load it twice ;)
            Visibility.removeClass(document.body,"normalCursor");
            Visibility.addClass(document.body,"waitCursor");
            ManageLayouts.callDWR("getTab",[activeTab.id,loadedTabContent(activeTab)]);
        }
    }

    function applyDialogSelection() {
        LayoutTab.selectValue(pickerTarget,ColourDialog.getSelectedColour());
        pickerDialog.hide();
    }

    function cancelDialogSelection() {
        if (typeof(ColourDialog)!="undefined") ColourDialog.init();
        pickerDialog.hide();
    }

    function showColourDialog (prop) {
        pickerTarget=prop;
        if (pickerDialog==null) {
            pickerDialog = new Ext.LayoutDialog("colourdialog-dlg", {
                modal:true,
                title:"Select Colour",
                width:390,
                height:340,
                shadow:true,
                autoCreate:true,
                resizable:false,
                center:{
                    tabPosition:"top",
                    alwaysShowTabs:true,
                    autoCreate:true
                },
                south:{
                    initialSize: 43,
                    titlebar: false,
                    collapsible: true,
                    animate: true,
                    autoCreate: true,
                    autoScroll: true
                }});
            var layout = pickerDialog.getLayout();
            layout.beginUpdate();
            layout.add('center', new Ext.ContentPanel('colourdialog-confluence', {title: 'Confluence', autoScroll: false, autoCreate: true}));
            layout.add('center', new Ext.ContentPanel('colourdialog-builder', {title: 'Builder', autoScroll: false, autoCreate: true}));
            layout.add('center', new Ext.ContentPanel('colourdialog-hsv', {title: 'HSV', autoScroll: false, autoCreate: true}));
            layout.add('center', new Ext.ContentPanel('colourdialog-pallete', {title: 'Palette', autoScroll: false, autoCreate: true}));
            layout.add('center', new Ext.ContentPanel('colourdialog-contrast', {title: 'Related', autoScroll: false, autoCreate: true}));
            layout.add('south', new Ext.ContentPanel('colourdialog-history', {title: 'History', autoScroll: true, autoCreate: true}));
            layout.endUpdate();
            var tabPanel = layout.getRegion("center").getTabs();
            tabPanel.addListener("tabchange",loadTabContent);
            tabPanel.activate("colourdialog-confluence");
            pickerDialog.addButton('OK', applyDialogSelection);
            pickerDialog.addButton('Cancel', cancelDialogSelection);
            var historyTab=Ext.get("colourdialog-history");
            loadTabContent({loaded:false},historyTab);
        }
        pickerDialog.show();
        if (typeof(ColourDialog)!="undefined") ColourDialog.init();
    }

    function getCurrentColour() {
        return LayoutTab.getValue(pickerTarget);
    }

    return {showColourDialog:showColourDialog, getCurrentColour:getCurrentColour};
})();