if (typeof(LayoutTab)=="undefined") var LayoutTab = (function () {
    var IE=(navigator.userAgent.indexOf("MSIE")>0);
    var OPERA=(navigator.userAgent.indexOf("MSIE")>0);

    var unappliedChanges=false;
    var managedLayout;
    var currentPanel;
    var iconPath="/download/resources/com.adaptavist.confluence.themes.sitebuilder:sitebuilder/icons/";
    var toolbar;
    var viewmenu;
    var editDialog;
    var panelNames={body:"Document",
        page:"Page",
        header:"Header Panel",
        menu:"Menu Panel",
        navigation:"Navigation Panel",
        leftSidebar:"Left Sidebar",
        leftSlider:"Left Slider",
        rightSidebar:"Right Sidebar",
        rightSlider:"Right Slider",
        title:"Title Panel",
        content:"Content Panel",
        footnotes:"Footnote Panel",
        footer:"Footer Panel"};
    var confColourNames={}
    confColourNames["property.style.topbarcolour"]="Top Bar";
    confColourNames["property.style.breadcrumbstextcolour"]="Breadcrumbs Text";
    confColourNames["property.style.spacenamecolour"]="Space Name Text";
    confColourNames["property.style.headingtextcolour"]="Heading Text";
    confColourNames["property.style.linkcolour"]="Links";
    confColourNames["property.style.bordercolour"]="Borders and Dividers";
    confColourNames["property.style.navbgcolour"]="Menu Bar Background";
    confColourNames["property.style.navtextcolour"]="Menu Bar Text";
    confColourNames["property.style.navselectedbgcolour"]="Menu Bar Background Highlight";
    confColourNames["property.style.navselectedtextcolour"]="Menu Bar Text Highlight";
    confColourNames["property.style.customcolour1"]="Custom 1";
    confColourNames["property.style.customcolour2"]="Custom 2";
    confColourNames["property.style.customcolour3"]="Custom 3";
    confColourNames["property.style.customcolour4"]="Custom 4";
    confColourNames["property.style.customcolour5"]="Custom 5";
    var confColours={};

    // -------------------- standard input utility functions
    function disableBtn(id,value) {
        var btn=document.getElementById(id);
        if (btn!=null) btn.disabled=value;
    }
    function disableProp(prop,value) {
        var inp=document.getElementById("layoutTab."+prop);
        if (inp!=null) inp.readOnly=value;
    }
    function disableCheckbox(prop,value) {
        var inp=document.getElementById("layoutTab."+prop);
        if (inp!=null) inp.disabled=value;
    }
    function disableSelect(prop,value) {
        var inp=document.getElementById("layoutTab."+prop);
        if (inp!=null) inp.disabled=value;
    }

    function setProp(prop,value) {
        var inp=document.getElementById("layoutTab."+prop);
        if (inp!=null) inp.value=value;
    }
    function setCheckbox(prop,value) {
        var inp=document.getElementById("layoutTab."+prop);
        if (inp!=null) inp.checked=value;
    }
    function setSelect(prop,value) {
        var inp=document.getElementById("layoutTab."+prop);
        if (inp!=null) {
            var i=inp.options.length;
            while (-1<--i) if ((""+inp.options[i].value)==value) inp.selectedIndex=i;
        }
    }

    function getProp(prop) {
        var inp=document.getElementById("layoutTab."+prop);
        if (inp!=null) return inp.value;
        return null;
    }
    function getCheckbox(prop) {
        var inp=document.getElementById("layoutTab."+prop);
        if (inp!=null) return inp.checked;
        return null;
    }
    function getSelect(prop) {
        var inp=document.getElementById("layoutTab."+prop);
        if (inp!=null) return inp.options[inp.selectedIndex].value
        return null;
    }

    // -------------------- toolbar control utility functions
    function disableToolbtn(id,state) {
        // disables a toolbar button
        if ((toolbar!=null) && (toolbar.items!=null)) {
            var btn = toolbar.items.get(id);
            if (btn!=null) {
                btn[(state) ? "disable" : "enable"]();
            }
        }
        if ((viewmenu!=null) && (viewmenu.items!=null)) {
            var btn = viewmenu.items.get(id);
            if (btn!=null) {
                btn[(state) ? "disable" : "enable"]();
            }
        }
    }
    function pressToolbtn(id,state) {
        // presses/releases a toolbar button
        if ((toolbar!=null) && (toolbar.items!=null)) {
            var btn = toolbar.items.get(id);
            if (btn!=null) {
                btn.toggle(state);
            }
        }
        if ((viewmenu!=null) && (viewmenu.items!=null)) {
            var btn = viewmenu.items.get(id);
            if (btn!=null) {
                btn.setChecked(state,true);
            }
        }
    }
    // -------------------- panel editor
    var cssValues={};// temporary storage for css properties;
    var cssDefaults={backgroundColor:"transparent",
        backgroundAttachment:"scroll",
        backgroundImage:"none",
        backgroundPosition:"top left",
        backgroundRepeat:"repeat",
        borderStyle:"none",
        borderWidth:"2px",
        borderColor:"#000000",
        width:"auto",
        maxWidth:"none",
        minWidth:"none",
        height:"auto",
        maxHeight:"none",
        minHeight:"none",
        padding:"0px",
        margin:"0px",
        color:"#000000",
        verticalAlign:"middle",
        textAlign:"left",
        overflow:"auto",
        fontFamily:"inherit",
        fontVariant:"normal",
        textTransform:"none",
        fontSize:"small",
        fontWeight:"normal",
        letterSpacing:"normal",
        wordSpacing:"normal",
        direction:"inherit",
        lineHeight:"normal",
        whiteSpace:"normal",
        textDecoration:"none",
        fontStyle:"normal"};// workaround for null values in the properties - resets stuff back to the browser's default settings
    // custom values
    var validateURL = function (value){
// todo: copy over regex from layoutManager
//        if (value.substr(0,3).toLowerCase()!="url") {
//            value="url("+value+")"
//        }
        return value;
    }
    var noValidation = function (value){
        return value;
    }
    var customPrompts={backgroundColor:{prompt:"Enter the new background colour (hex/rgb/named)",validate:noValidation},
            backgroundPosition:{prompt:"Enter the new background position (% % or px px)",validate:noValidation},
            backgroundImage:{prompt:"Enter the URL to the background image",validate:validateURL},
            borderWidth:{prompt:"Enter the new border width (px/%)",validate:noValidation},
            borderColor:{prompt:"Enter the new border colour (hex/rgb/named)",validate:noValidation},
            verticalAlign:{prompt:"Enter the new vertical alignment (px/%)",validate:noValidation},
            padding:{prompt:"Enter the new padding (px/%)",validate:noValidation},
            margin:{prompt:"Enter the new margin (px/%)",validate:noValidation},
            maxWidth:{prompt:"Enter the new maximum width (px/%/em)",validate:noValidation},
            minWidth:{prompt:"Enter the new minimum width (px/%/em)",validate:noValidation},
            width:{prompt:"Enter the new width (px/%/em)",validate:noValidation},
            maxHeight:{prompt:"Enter the new maximum height (px/%/em)",validate:noValidation},
            minHeight:{prompt:"Enter the new minimum height (px/%/em)",validate:noValidation},
            height:{prompt:"Enter the new height (px/%/em)",validate:noValidation},
            fontFamily:{prompt:"Enter the new font name/family or comma separated list of names/families",validate:noValidation},
            fontSize:{prompt:"Enter the new font size (px/pt/%)",validate:noValidation},
            fontWeight:{prompt:"Enter the new font weight (0-1000)",validate:noValidation},
            color:{prompt:"Enter the new text colour (hex/rgb/named)",validate:noValidation},
            letterSpacing:{prompt:"Enter the new letter spacing (px)",validate:noValidation},
            wordSpacing:{prompt:"Enter the new word spacing (px)",validate:noValidation},
            lineHeight:{prompt:"Enter the new line height (number/px/%)",validate:noValidation}};
    var customValue = function (prop) {
        var p=customPrompts[prop];
        if (p==null) return false;
        var defaultedValue = (cssValues[prop]==null) ? cssDefaults[prop] : cssValues[prop];
        var value=prompt(p.prompt,defaultedValue);
        if ((value!=defaultedValue) && (value!=null)) {
            value=p.validate(value);
            if (value!=null) selectValue(prop,value);
        }
    }
    function setPip(prop,value,img) {
        var pip = document.getElementById("setting-"+prop+value);
        if (pip!=null) {
            pip.src=img;
        } else {
            pip = document.getElementById("custom-"+prop);
            if (pip!=null) pip.src=img;
        }
    }
    function updateCSSmenu(prop,value) {
        if (value=="inherit") value=null;
        var defaultedValue = (value==null || value==undefined) ? cssDefaults[prop] : value;
        // update the custom prop with teh current value
//        var inp= document.getElementById("custom"+prop+"input");
//        if (inp!=null) inp.value=defaultedValue;
        var pip;
        // remove the default
        if (cssDefaults[prop]!=defaultedValue) {
            setPip(prop,cssDefaults[prop],contextPath+"/images/border/spacer.gif");
        }
        // remove the previously selected value
        if (cssValues[prop]!=defaultedValue) {
            setPip(prop,cssValues[prop],contextPath+"/images/border/spacer.gif");
        }
        // set the current dot
        setPip(prop,defaultedValue,contextPath+iconPath+"greendot.gif");
    }

    function setValue(element, property, value) {
        if (element!=null) {
            if (value==null || value=="EMPTY") value="";
            element.style[property]=value;
        }
    }

    function selectValue(prop,value) {
        if (value=="inherit") value=null;
        // called by the css menu options to set/store a value & update the panel editor
        if (cssDefaults[prop]==null) return;// drop out if it's not a recognised css prop (ie: it's some other panel prop)
        var defaultedValue = (value==null || typeof(value)=="undefined") ? cssDefaults[prop] : value;
        switch (prop) {
            case "backgroundColor":
            case "borderColor":
            case "color":
                setValue(document.getElementById("panel-display"), prop, (confColours[defaultedValue]!=null) ? confColours[defaultedValue] : defaultedValue);
                break;

            case "backgroundImage":
                if (defaultedValue!=null && defaultedValue!="EMPTY") {
                    var display = document.getElementById("panel-display");
                    if (display!=null) ManageLayouts.callDWR("getBackgroundImage",[defaultedValue,onGetBackgroundImage(display)]);
                }
                break;

            case "margin":
                setValue(document.getElementById("panel-margin"), "padding", defaultedValue);
                setValue(document.getElementById("panel-margin"), "borderStyle", (defaultedValue=="0px") ? "none" : "dashed");
                break;

            case "padding":
                setValue(document.getElementById("panel-display"), "padding", defaultedValue);
                setValue(document.getElementById("panel-display"), "borderStyle", (defaultedValue=="0px") ? "none" : "dotted");
                break;

            case "width":
            case "maxWidth":
            case "minWidth":
            case "height":
            case "maxHeight":
            case "minHeight":
                if ((IE) && ("auto"==defaultedValue)) defaultedValue="";
                if ((IE) && ("none"==defaultedValue)) defaultedValue="";
            default:
                setValue(document.getElementById("panel-display"), prop, defaultedValue);
                break;
        }
        // update menu
        updateCSSmenu(prop,defaultedValue);
        // store the value in the temporary array
        if (value!=null) {
            cssValues[prop]=value;
            changed();
        }
    }

    function applyPanel() {
        // called by 'apply' button to store the currently edited panel date into the layout preview
        if (!ManageLayouts.hasLayoutPermission(ManageLayouts.EDIT_PERMISSION)) return alert("You do not have permission to edit this layout.");
        var data=managedLayout.layout[currentPanel];
        var i;
        for (i in cssValues) data[i]=cssValues[i];
        if (getProp("content")!=null) data.content=getProp("content");
        if (data.defer!=null) data.defer=getCheckbox("defer");
        if (data.collapse!=null) data.collapse=getCheckbox("collapse");
        if (data.renderMode!=null) data.renderMode=getSelect("renderMode");
        updatePanel(currentPanel);
        unchanged();
        ManageLayouts.changed();
    }
    function askApplyChanges() {
        if (confirm("There are changes in the panel preview that have not yet been applied, apply them?")) {
            applyPanel();
        } else {
            reloadPanel();
        }
    }
    function editPanel(panelID) {
        // check this is a valid panel ID
        if (panelID==null || panelNames[panelID]==null) return;
        Visibility.setVisibility("panel-editor",true);
        // updates the panel editor to display the specified panel
        if ((panelID!=currentPanel) && (unappliedChanges) && ManageLayouts.hasLayoutPermission(ManageLayouts.EDIT_PERMISSION)) askApplyChanges();
        // hide the rows in the content panel (we will update them later)
        Visibility.setVisibility("layoutTab.row.nosettings",true);
        Visibility.setVisibility("layoutTab.row.content",false);
        Visibility.setVisibility("layoutTab.row.defer",false);
        Visibility.setVisibility("layoutTab.row.collapse",false);
        Visibility.setVisibility("layoutTab.row.renderMode",false);
        Visibility.setVisibility("layoutTab.row.apply",false);
        setProp("content",null);
        // disable buttons
        disableBtn("panel-editor-apply",managedLayout!=null && !ManageLayouts.hasLayoutPermission(ManageLayouts.EDIT_PERMISSION));
        disableBtn("panel-editor-cancel",panelID==null);
        // set the panel name display
        Ext.get("panelname").update(panelNames[panelID]);
        if (Ext.get("panel-content")!=null) Ext.get("panel-content").update(panelNames[panelID]);
        // prepare the data
        currentPanel=panelID;
        var i;
        for (i in cssValues) selectValue(i);// reset the pips back to their original values
        cssValues={};// clear out the old set of values
        updateContent();// apply the new set of values
        unchanged();
    }
    function onGetBackgroundImage(panel) {
        return function(bgImage) {
            if (bgImage!=null) {
                panel.style.backgroundImage=bgImage;
            }
        }
    }
    function updatePanel(panelID) {
        // takes the panel data from DWR and applies it to the layout editor panel
        var panel=document.getElementById("mini-"+panelID);
        if (panel==null) return alert("unable to locate panel : "+panelID);
        var i;
        var panelData = managedLayout.layout[panelID];
        for (i in panelData) if (panelData[i]=="inherit") delete panelData[i];
        for (i in panelData) switch (i) {
            case "backgroundImage":
                if (panelData[i]==null) {
                    panel.style[i]="";
                } else if (panelData[i].match("([^:]*:){0,1}[^\^]*^.*")) {
                    ManageLayouts.callDWR("getBackgroundImage",[panelData[i],onGetBackgroundImage(panel)]);
                } else {
                    panel.style[i]=panel.style[i]=panelData[i];
                }
                break;

            case "backgroundColor":
            case "borderColor":
            case "color":
                panel.style[i]=(typeof(confColours[panelData[i]])!="undefined") ? confColours[panelData[i]] : ((panelData[i]==null) ? "" : panelData[i]);
                break;

            case "visible":
                if (panelID!="leftSlider" && panelID!="rightSlider") {
                    Visibility.setVisibility("mini-"+panelID,panelData[i]);
                }
                pressToolbtn(panelID,panelData[i]);
                if (panelID=="leftSidebar") {
                    Visibility.setVisibility("mini-leftSlider", panelData[i] && managedLayout.layout.leftSlider.visible);
                    pressToolbtn("leftSlider",panelData[i] && managedLayout.layout.leftSlider.visible);
                    disableToolbtn("leftSlider",!panelData[i]);
                } else if (panelID=="leftSlider") {
                    Visibility.setVisibility("mini-leftSlider",panelData[i] && managedLayout.layout.leftSidebar.visible);
                } else if (panelID=="rightSidebar") {
                    Visibility.setVisibility("mini-rightSlider", panelData[i] && managedLayout.layout.rightSlider.visible);
                    pressToolbtn("rightSlider",panelData[i] && managedLayout.layout.rightSlider.visible);
                    disableToolbtn("rightSlider",!panelData[i]);
                } else if (panelID=="rightSlider") {
                    Visibility.setVisibility("mini-rightSlider",panelData[i] && managedLayout.layout.rightSidebar.visible);
                }
                break;

            case "defer":
            case "content":
            case "renderMode":
                // do nothing
                break;
            case "collapse":
                Visibility.setVisibility("mini-"+panelID, !panelData[i]);
//                Visibility.setVisibilityCookie(panelID,!panelData[i]);
                break;
            default:
                panel.style[i]=(panelData[i]==null) ? "" : panel.style[i]=panelData[i];
        }
    }
    function reloadPanel() {
        editPanel(currentPanel);
    }
    function togglePanel(btn) {
        var panelID=btn.id;
        // shows/hides the panel in the layout editor
        if (!ManageLayouts.hasLayoutPermission(ManageLayouts.EDIT_PERMISSION)) return alert("You do not have permission to edit this layout");
        managedLayout.layout[panelID].visible=!managedLayout.layout[panelID].visible;
        updatePanel(panelID);
        ManageLayouts.changed();
    }

    function applyContent() {
        applyPanel();
        editDialog.hide();
    }

    function resizeTextBox (){
        var w=editDialog.size.width-44;
        var h=editDialog.size.height-144;
        Ext.get("menuTab.viewMenu").setSize(w,h);
        Ext.get("menuTab.editMenu").setSize(w,h);
    };

    function editContent() {
        if (!ManageLayouts.hasLayoutPermission(ManageLayouts.EDITPANEL_PERMISSION)) return alert("You do not have permission to edit the panel content");
        if (editDialog==null) {
            editDialog = new Ext.LayoutDialog("contentEdit-dlg", {
                modal:false,
                width:700,
                height:500,
                shadow:true,
                minWidth:300,
                minHeight:300,
                autoCreate:true,
                constraintoviewport:false,
                center:{
                    tabPosition:"top",
                    alwaysShowTabs:true,
                    autoCreate:true
                }});
            var layout = editDialog.getLayout();
            layout.beginUpdate();
            layout.add('center', new Ext.ContentPanel('contentEdit-content', {title: 'Content', autoScroll: true, autoCreate: true}));
            layout.add('center', new Ext.ContentPanel('contentEdit-options', {title: 'Options', autoScroll: true, autoCreate: true}));
            layout.endUpdate();
            var tabPanel = layout.getRegion("center").getTabs();
            tabPanel.addListener("tabchange",loadTabContent);
            tabPanel.activate("contentEdit-content");
            tabPanel.activate("contentEdit-options");
            tabPanel.activate("contentEdit-content");
            editDialog.addButton('OK', applyContent);//.disable();
            editDialog.addButton('Cancel', editDialog.hide, editDialog);
//            editDialog.addListener("resize",resizeTextBox);
        }
        updateContent();
        //editDialog.show("mini-"+currentPanel);
        editDialog.show();
    }
    function updateContent() {
        var changed=unappliedChanges;
        var data=managedLayout.layout[currentPanel];
        if (data!=null) {
            Visibility.setVisibility("layoutTab.row.nocontent",true);
            Visibility.setVisibility("layoutTab.row.content",false);
            Visibility.setVisibility("layoutTab.row.nosettings",true);
            Visibility.setVisibility("layoutTab.row.settings",false);
            Visibility.setVisibility("layoutTab.row.defer",false);
            Visibility.setVisibility("layoutTab.row.collapse",false);
            var i;
            for (i in data) selectValue(i,data[i]);
            var disable=!ManageLayouts.hasLayoutPermission(ManageLayouts.EDIT_PERMISSION);
            if (data.content!=null) {
                Visibility.setVisibility("layoutTab.row.nocontent",false);
                Visibility.setVisibility("layoutTab.row.content",true);
                disableProp("content",disable);
                setProp("content",data.content);
                disableBtn("panel-editor-content",false);
            } else {
                disableBtn("panel-editor-content",true);
            }
            if (data.defer!=null) {
                Visibility.setVisibility("layoutTab.row.nosettings",false);
                Visibility.setVisibility("layoutTab.row.settings",true);
                Visibility.setVisibility("layoutTab.row.defer",true);
                disableCheckbox("defer",disable);
                setCheckbox("defer",data.defer);
            }
            if (data.collapse!=null) {
                Visibility.setVisibility("layoutTab.row.nosettings",false);
                Visibility.setVisibility("layoutTab.row.settings",true);
                Visibility.setVisibility("layoutTab.row.collapse",true);
                disableCheckbox("collapse",disable);
                setCheckbox("collapse",data.collapse);
            }
            if (data.renderMode!=null) {
                Visibility.setVisibility("layoutTab.row.nosettings",false);
                Visibility.setVisibility("layoutTab.row.settings",true);
                Visibility.setVisibility("layoutTab.row.renderMode",true);
                disableSelect("renderMode",disable);
                setSelect("renderMode",data.renderMode);
            }
        }
        unappliedChanges=changed;// preserve the state of unappliedChanges
    }

    function updateDisplay(data) {
        if (data==null) return;
        // reset the button states
        var disabled=!ManageLayouts.hasLayoutPermission(ManageLayouts.EDIT_PERMISSION);
        var i;
        for (i in panelNames) if (typeof(data.layout[i].visible)!="undefined") {
            disableToolbtn(i,disabled);
        }
        // apply the data
        managedLayout=data;
        for (i in panelNames) {
            updatePanel(i);
        }
        editPanel(currentPanel);
        unchanged();
    }

    function changed() {
        unappliedChanges=true;
        ManageLayouts.updateTitle(" (panel edited)");
    }

    function unchanged() {
        unappliedChanges=false;
        ManageLayouts.updateTitle("");
    }

    function updateSettings(layout) {
        if (unappliedChanges) askApplyChanges();
        return layout;
    }

    function highlightPanel() {
        if (typeof(Effect)!="undefined" && typeof(Effect.Highlight)!="undefined") {
            new Effect.Highlight("mini-"+currentPanel);
        }
    }

    // tab loading
    function loadedTabContent(activeTab) {
        return function (tabcontent) {
            Visibility.removeClass(document.body,"waitCursor");
            Visibility.addClass(document.body,"normalCursor");
            activeTab.setContent(tabcontent,true);
            editPanel(currentPanel);
        }
    }
    function loadTabContent(tabPanel, activeTab) {
        if (!activeTab.loaded) {
            activeTab.loaded=true;// dont really want to try and load it twice ;)
            Visibility.removeClass(document.body,"normalCursor");
            Visibility.addClass(document.body,"waitCursor");
            ManageLayouts.callDWR("getTab",[activeTab.id,loadedTabContent(activeTab)]);
        }
    }

    var borderLayout = Ext.get("layoutmanager").borderLayout;
    function initialiseDisplay(data) {
        borderLayout.beginUpdate();
        toolbar = new Ext.Toolbar("layouttoolbar");
        var i;
        var p;
        var pn;
        for (i in panelNames) if (typeof(data.layout[i].visible)!="undefined") {
            pn = panelNames[i]
            p = pn.indexOf(" Panel");
            if (p>-1) pn=pn.substr(0,p);
            toolbar.add({cls: 'x-btn-text',
                    id:i,
                    text:pn,
                    handler:togglePanel,
                    enableToggle:true,
                    tooltip:"Toggle the "+panelNames[i]+" display"});
        }
        borderLayout.endUpdate();
    }
    initialiseDisplay(ManageLayouts.getManagedLayout());

    function clearValue(parameter) {
        if (unappliedChanges) askApplyChanges();
        ManageLayouts.clearValue(currentPanel+"."+parameter);
    }

    function getValue (propname) {
        return cssValues[propname];
    }

    function getPanelProps(prop) {
        var layout=managedLayout.layout;
        o={};
        o["body"]=layout.body[prop];
        o["page"]=layout.page[prop];
        o["header"]=layout.header[prop];
        o["menu"]=layout.menu[prop];
        o["navigation"]=layout.navigation[prop];
        o["title"]=layout.title[prop];
        o["content"]=layout.content[prop];
        o["leftSidebar"]=layout.leftSidebar[prop];
        o["leftSlider"]=layout.leftSlider[prop];
        o["rightSidebar"]=layout.rightSidebar[prop];
        o["rightSlider"]=layout.rightSlider[prop];
        o["footnotes"]=layout.footnotes[prop];
        o["footer"]=layout.footer[prop];
        return o;
    }

    function storeProps(o,prop) {
        var props=getPanelProps(prop);
        var colour,panel;
        for (panel in props) {
            colour=props[panel];
            if (o[colour]==null) {
                o[colour]=[];
            }
            o[colour].push(panel);
        }
    }

    function getPanelColours() {
        var o={};
        if (managedLayout!=null) {
            storeProps(o,"backgroundColor");
            storeProps(o,"borderColor");
            storeProps(o,"color");
        }
        return o;
    }

    function getPanelNames() {
        return panelNames;
    }

    function onGetConfColurs(colours) {
        confColours=colours;
        updateDisplay(ManageLayouts.getManagedLayout());
    }
    var spacekey = null;
    if (document.location.href.indexOf("key")>-1) {
        var s=document.location.href.indexOf("key")+4;
        var e=document.location.href.indexOf("&",s);
        if (e<0) {
            e=document.location.href.length;
        }
        spacekey=document.location.href.substr(s,e-s);
    }
    ManageLayouts.callDWR("getColourScheme",[spacekey,onGetConfColurs]);

    function getConfColours() {
        return confColours;
    }

    function getConfColourNames() {
        return confColourNames;
    }

//    var active=true;
//    function setActive(tabPanel, activeTab) {
//        active = (activeTab.id=="layoutTab");
//        if (active) updateDisplay(ManageLayouts.getManagedLayout());
//    }
//    borderLayout.getRegion("center").getTabs().addListener("tabchange",setActive);
    function layoutLoaded(managedLayout) {
//        if (active) updateDisplay(data);
        updateDisplay(managedLayout);
    }

    return {togglePanel:togglePanel,
            editPanel:editPanel,
            editContent:editContent,
            applyPanel:applyPanel,
            reloadPanel:reloadPanel,
            highlightPanel:highlightPanel,
            selectValue:selectValue,
            clearValue:clearValue,
            customValue:customValue,
            getValue:getValue,
            getPanelColours:getPanelColours,
            getPanelNames:getPanelNames,
            getConfColours:getConfColours,
            getConfColourNames:getConfColourNames,
            changed:changed,
            updateSettings:updateSettings,
            layoutLoaded:layoutLoaded};
})();

