if (typeof(MenuTab)=="undefined") var MenuTab = (function () {
    var editDialog;

    // -------------------- standard input utility functions
    function disableProp(prop,value) {
        var inp=document.getElementById("menuTab."+prop);
        if (inp!=null) inp.readOnly=value;
    }
    function disableCheckbox(prop,value) {
        var inp=document.getElementById("menuTab."+prop);
        if (inp!=null) inp.disabled=value;
    }
    function disableSelect(prop,value) {
        var inp=document.getElementById("menuTab."+prop);
        if (inp!=null) inp.disabled=value;
    }

    function setProp(prop,value) {
        var inp=document.getElementById("menuTab."+prop);
        if (inp!=null) inp.value=value;
    }
    function setCheckbox(prop,value) {
        var inp=document.getElementById("menuTab."+prop);
        if (inp!=null) inp.checked=value;
    }
    function setSelect(prop,value) {
        var inp=document.getElementById("menuTab."+prop);
        if (inp!=null) {
            var i=inp.options.length;
            while (-1<--i) {
                if ((""+inp.options[i].value)==value) {
                    inp.selectedIndex=i;
                    break;
                }
            }
        }
    }
    function updateDisplay(managedLayout) {
        if (managedLayout==null) return;
        var layout = managedLayout.layout;
        setProp("viewMenu", layout.hmenu.viewMenu);
        setProp("editMenu", layout.hmenu.editMenu);
        setSelect("menuSkin", layout.hmenu.menuSkin);
        setCheckbox("showIcons", layout.hmenu.showIcons);
        setCheckbox("electric", layout.hmenu.electric);
        setCheckbox("tooltips", layout.hmenu.tooltips);
        setCheckbox("shadow", layout.hmenu.shadow);
        setCheckbox("smoothShadows", layout.hmenu.smoothShadows);
        setCheckbox("blink", layout.hmenu.blink);
        setCheckbox("lazy", layout.hmenu.lazy);
        setCheckbox("scroll", layout.hmenu.scroll);
        setCheckbox("useMenuJS", layout.useMenuJS);
        var disabled=!ManageLayouts.hasLayoutPermission(ManageLayouts.EDIT_PERMISSION);
        disableProp("viewMenu", disabled);
        disableProp("editMenu", disabled);
        disableCheckbox("dialogBtn", disabled);
        disableSelect("menuSkin", disabled);
        disableCheckbox("showIcons", disabled);
        disableCheckbox("electric", disabled);
        disableCheckbox("tooltips", disabled);
        disableCheckbox("shadow", disabled);
        disableCheckbox("smoothShadows", disabled);
        disableCheckbox("blink", disabled);
        disableCheckbox("lazy", disabled);
        disableCheckbox("scroll", disabled);
        disableCheckbox("useMenuJS", disabled);
    }

    function getProp(prop,defaultValue) {
        var inp=document.getElementById("menuTab."+prop);
        if (inp!=null) return inp.value;
        return defaultValue;
    }
    function getCheckbox(prop) {
        var inp=document.getElementById("menuTab."+prop);
        if (inp!=null) return inp.checked;
    }
    function getSelect(prop) {
        var inp=document.getElementById("menuTab."+prop);
        if (inp!=null) return inp.options[inp.selectedIndex].value
        return null;
    }
    function updateSettings(layout) {
        if (layout==null) return;
        layout.hmenu.viewMenu=getProp("viewMenu",layout.hmenu.viewMenu);
        layout.hmenu.editMenu=getProp("editMenu",layout.hmenu.editMenu);
        layout.hmenu.menuSkin=getSelect("menuSkin");
        layout.hmenu.showIcons=getCheckbox("showIcons");
        layout.hmenu.electric=getCheckbox("electric");
        layout.hmenu.tooltips=getCheckbox("tooltips");
        layout.hmenu.shadow=getCheckbox("shadow");
        layout.hmenu.smoothShadows=getCheckbox("smoothShadows");
        layout.hmenu.blink=getCheckbox("blink");
        layout.hmenu.lazy=getCheckbox("lazy");
        layout.hmenu.scroll=getCheckbox("scroll");
        layout.useMenuJS=getCheckbox("useMenuJS");
        return layout;
    }

    function genTab(tab){
        return "<table class=\"layoutParameter-table\" style=\"width:98%;height:98%\"><tbody><tr class=\"layoutParameter-row\"><td class=\"layoutParameter-property\"><div class=\"layoutParameter-section\">"+
                 "<div class=\"layoutParameter-title\">"+tab+" (<a class=\"layoutParameter-clear\" href=\"javascript:ManageLayouts.clearValue('hmenu."+tab+"');\">Use Default...</a>)</div>"+
                 "<textarea class=\"layoutParameter-property\" id=\"menuTab."+tab+"\" rows=\"21\" style=\"width:100%;height:100%;\" onchange=\"ManageLayouts.changed();\"></textarea>"+
               "</div></td></tr></tbody></table>";
    }

    function applyDialogSelection() {
        editDialog.hide();
    }

    function cancelDialogSelection() {
        updateDisplay(ManageLayouts.getManagedLayout());
        editDialog.hide();
    }

    function resizeTextBox (){
        var w=editDialog.size.width-44;
        var h=editDialog.size.height-144;
        Ext.get("menuTab.viewMenu").setSize(w,h);
        Ext.get("menuTab.editMenu").setSize(w,h);
    };

    function editContent(tab) {
        if (editDialog==null) {
            editDialog = new Ext.LayoutDialog("menuEdit-dlg", {
                modal:false,
                width:700,
                height:500,
                shadow:true,
                minWidth:300,
                minHeight:300,
                autoCreate:true,
                constraintoviewport:false,
                center:{
                    tabPosition:"top",
                    alwaysShowTabs:true,
                    autoCreate:true
                }});
            var layout = editDialog.getLayout();
            layout.beginUpdate();
            layout.add('center', new Ext.ContentPanel('menuTab-viewMenu', {title: 'View Menu', autoScroll: true, autoCreate: true}));
            layout.add('center', new Ext.ContentPanel('menuTab-editMenu', {title: 'Edit Menu', autoScroll: true, autoCreate: true}));
            layout.endUpdate();
            var tabPanel = layout.getRegion("center").getTabs();
            tabPanel.getTab("menuTab-viewMenu").setContent(genTab("viewMenu"));
            tabPanel.getTab("menuTab-editMenu").setContent(genTab("editMenu"));
            editDialog.addButton('OK', applyDialogSelection);
            editDialog.addButton('Cancel', cancelDialogSelection);
            editDialog.addListener("resize",resizeTextBox);
            updateDisplay(ManageLayouts.getManagedLayout());
        }
        editDialog.show();
        editDialog.getLayout().getRegion("center").getTabs().activate("menuTab-"+tab);
    }

//    var active=true;
//    function setActive(tabPanel, activeTab) {
//        active = (activeTab.id=="menuTab");
//        if (active) updateDisplay(ManageLayouts.getManagedLayout());
//    }
//    Ext.get("layoutmanager").borderLayout.getRegion("center").getTabs().addListener("tabchange",setActive);
    function layoutLoaded(managedLayout) {
//        if (active) updateDisplay(managedLayout);
        updateDisplay(managedLayout);
    }
    updateDisplay(ManageLayouts.getManagedLayout());

    return {updateSettings:updateSettings,
            updateDisplay:updateDisplay,
            layoutLoaded:layoutLoaded,
            editContent:editContent};
})();

