if (typeof(OptionsTab)=="undefined") var OptionsTab = (function () {
    // -------------------- standard input utility functions
    function disableProp(prop,value) {
        var inp=document.getElementById("optionsTab."+prop);
        if (inp!=null) inp.readOnly=value;
    }
    function disableCheckbox(prop,value) {
        var inp=document.getElementById("optionsTab."+prop);
        if (inp!=null) inp.disabled=value;
    }
    function disableSelect(prop,value) {
        var inp=document.getElementById("optionsTab."+prop);
        if (inp!=null) inp.disabled=value;
    }

    function setProp(prop,value) {
        var inp=document.getElementById("optionsTab."+prop);
        if (inp!=null) inp.value=value;
    }
    function setCheckbox(prop,value) {
        var inp=document.getElementById("optionsTab."+prop);
        if (inp!=null) inp.checked=value;
    }
    function setSelect(prop,value) {
        var inp=document.getElementById("optionsTab."+prop);
        if (inp!=null) {
            var i=inp.options.length;
            while (-1<--i) if ((""+inp.options[i].value)==value) inp.selectedIndex=i;
        }
    }
    function updateDisplay(managedLayout) {
        if (managedLayout==null) return;
        var layout = managedLayout.layout;
        setCheckbox("removeDashboard",layout.removeDashboard);
        setCheckbox("removeSpace",layout.removeSpace);
        setCheckbox("removeHome",layout.removeHome);
        setProp("breadcrumbSeparator",layout.breadcrumbSeparator);
        setProp("breadcrumbPrefix",layout.breadcrumbPrefix);
        setProp("shellWidth",layout.shellWidth);
        setProp("shellHeight",layout.shellHeight);
        setSelect("pageAlignment",layout.pageAlignment);
        setProp("printableLayout",layout.printableLayout);
        setProp("pageTitle",layout.pageTitle);
        setProp("docType",layout.docType);
        setProp("htmltag",layout.htmltag);
        setSelect("pragma",layout.pragma);
        setSelect("expires",layout.expires);
        setCheckbox("showDebug",layout.showDebug);
        setCheckbox("showVersion",layout.showVersion);
        setCheckbox("showComments",layout.showComments);
        setProp("favicon",layout.favicon);
        setCheckbox("metaKeywords",layout.metaKeywords);
        setCheckbox("metaDescription",layout.metaDescription);
        setCheckbox("metaAuthor",layout.metaAuthor);
        setCheckbox("robotsDirectory",layout.robotsDirectory);
        setCheckbox("robotsIndex",layout.robotsIndex);
        setCheckbox("robotsFollow",layout.robotsFollow);
        setCheckbox("robotsArchive",layout.robotsArchive);
        setCheckbox("robotsSnippet",layout.robotsSnippet);
        setCheckbox("useOpensearch",layout.useOpensearch);
        setCheckbox("minorEdit",layout.minorEdit);
        setCheckbox("useCustomHtmlHead",layout.useCustomHtmlHead);
        setCheckbox("useCustomHtmlBody",layout.useCustomHtmlBody);
        setCheckbox("useCustomHtmlFoot",layout.useCustomHtmlFoot);
        var disabled=!ManageLayouts.hasLayoutPermission(ManageLayouts.EDIT_PERMISSION);
        var advanced=!(ManageLayouts.hasLayoutPermission(ManageLayouts.EDIT_PERMISSION) && ManageLayouts.hasGlobalPermission(ManageLayouts.EDIT_ADVANCED));
        disableCheckbox("removeDashboard", disabled);
        disableCheckbox("removeSpace", disabled);
        disableCheckbox("removeHome", disabled);
        disableProp("breadcrumbSeparator",disabled);
        disableProp("breadcrumbPrefix",disabled);
        disableProp("shellWidth",disabled);
        disableProp("shellHeight",disabled);
        disableSelect("pageAlignment",disabled);
        disableProp("printableLayout",disabled);
        disableProp("pageTitle",advanced);
        disableProp("docType",advanced);
        disableProp("htmltag",advanced);
        disableSelect("pragma",advanced);
        disableSelect("expires",advanced || "no-cache"==layout.pragma);
        disableCheckbox("showDebug", disabled);
        disableCheckbox("showVersion", disabled);
        disableCheckbox("showComments", disabled);
        disableProp("favicon",disabled);
        disableCheckbox("metaKeywords", disabled);
        disableCheckbox("metaDescription", disabled);
        disableCheckbox("metaAuthor", disabled);
        disableCheckbox("robotsDirectory", disabled);
        disableCheckbox("robotsIndex", disabled);
        disableCheckbox("robotsFollow", disabled);
        disableCheckbox("robotsArchive", disabled);
        disableCheckbox("robotsSnippet", disabled);
        disableCheckbox("useOpensearch", disabled);
        disableCheckbox("minorEdit", disabled);
        disableCheckbox("useCustomHtmlHead", disabled);
        disableCheckbox("useCustomHtmlBody", disabled);
        disableCheckbox("useCustomHtmlFoot", disabled);
    }

    function getProp(prop) {
        var inp=document.getElementById("optionsTab."+prop);
        if (inp!=null) return inp.value;
        return null
    }
    function getCheckbox(prop) {
        var inp=document.getElementById("optionsTab."+prop);
        if (inp!=null) return inp.checked;
    }
    function getSelect(prop) {
        var inp=document.getElementById("optionsTab."+prop);
        if (inp!=null) return inp.options[inp.selectedIndex].value
        return null;
    }
    function updateSettings(layout) {
        layout.removeDashboard=getCheckbox("removeDashboard");
        layout.removeSpace=getCheckbox("removeSpace");
        layout.removeHome=getCheckbox("removeHome");
        layout.breadcrumbSeparator=getProp("breadcrumbSeparator");
        layout.breadcrumbPrefix=getProp("breadcrumbPrefix");
        layout.shellWidth=getProp("shellWidth");
        layout.shellHeight=getProp("shellHeight");
        layout.pageAlignment=getSelect("pageAlignment");
        layout.printableLayout=getProp("printableLayout");
        layout.pageTitle=getProp("pageTitle");
        layout.docType=getProp("docType");
        layout.htmltag=getProp("htmltag");
        layout.pragma=getSelect("pragma");
        layout.expires=getSelect("expires");
        layout.showDebug=getCheckbox("showDebug");
        layout.showVersion=getCheckbox("showVersion");
        layout.showComments=getCheckbox("showComments");
        layout.favicon=getProp("favicon");
        layout.metaKeywords=getCheckbox("metaKeywords");
        layout.metaDescription=getCheckbox("metaDescription");
        layout.metaAuthor=getCheckbox("metaAuthor");
        layout.robotsDirectory=getCheckbox("robotsDirectory");
        layout.robotsIndex=getCheckbox("robotsIndex");
        layout.robotsFollow=getCheckbox("robotsFollow");
        layout.robotsArchive=getCheckbox("robotsArchive");
        layout.robotsSnippet=getCheckbox("robotsSnippet");
        layout.useOpensearch=getCheckbox("useOpensearch");
        layout.minorEdit=getCheckbox("minorEdit");
        layout.useCustomHtmlHead=getCheckbox("useCustomHtmlHead");
        layout.useCustomHtmlBody=getCheckbox("useCustomHtmlBody");
        layout.useCustomHtmlFoot=getCheckbox("useCustomHtmlFoot");
        return layout;
    }

    function setPragma(pragma) {
        if (pragma=="no-cache") {
            disableSelect("cacheControl",true);
        } else {
            var advanced=!(ManageLayouts.hasLayoutPermission(ManageLayouts.EDIT_PERMISSION) && ManageLayouts.hasGlobalPermission(ManageLayouts.EDIT_ADVANCED));
            disableSelect("expires",advanced);
        }
        ManageLayouts.changed();
    }

//    var active=true;
//    function setActive(tabPanel, activeTab) {
//        active = (activeTab.id=="optionsTab");
//        if (active) updateDisplay(ManageLayouts.getManagedLayout());
//    }
//    Ext.get("layoutmanager").borderLayout.getRegion("center").getTabs().addListener("tabchange",setActive);
    function layoutLoaded(managedLayout) {
//        if (active) updateDisplay(managedLayout);
        updateDisplay(managedLayout);
    }
    updateDisplay(ManageLayouts.getManagedLayout());

    return {updateSettings:updateSettings,
            updateDisplay:updateDisplay,
            layoutLoaded:layoutLoaded,
            setPragma:setPragma};
})();

