if (typeof(PermissionsTab)=="undefined") var PermissionsTab = (function () {
    // -------------------- standard input utility functions
    function disableProp(prop,value) {
        var inp=document.getElementById("permissionsTab."+prop);
        if (inp!=null) inp.readOnly=value;
    }
    function disableCheckbox(prop,value) {
        var inp=document.getElementById("permissionsTab."+prop);
        if (inp!=null) inp.disabled=value;
    }
    function disableSelect(prop,value) {
        var inp=document.getElementById("permissionsTab."+prop);
        if (inp!=null) inp.disabled=value;
    }

    function setProp(prop,value) {
        var inp=document.getElementById("permissionsTab."+prop);
        if (inp!=null) inp.value=value;
    }
    function setCheckbox(prop,value) {
        var inp=document.getElementById("permissionsTab."+prop);
        if (inp!=null) inp.checked=value;
    }
    function setSelect(prop,value) {
        var inp=document.getElementById("permissionsTab."+prop);
        if (inp!=null) {
            var i=inp.options.length;
            while (-1<--i) if ((""+inp.options[i].value)==value) inp.selectedIndex=i;
        }
    }
    function updateDisplay(managedLayout) {
        if (managedLayout==null) return;
        var layout = managedLayout.layout;
        if (layout.permissions.view==null) layout.permissions.view = [];
        if (layout.permissions.edit==null) layout.permissions.edit = [];
        if (layout.permissions.editpanel==null) layout.permissions.editpanel = [];
        if (layout.permissions.child==null) layout.permissions.child = [];
        setProp("view",layout.permissions.view.join(","));
        setProp("edit",layout.permissions.edit.join(","));
        setProp("editpanel",layout.permissions.editpanel.join(","));
        setProp("child",layout.permissions.child.join(","));
        var disabled=!ManageLayouts.hasLayoutPermission(ManageLayouts.EDIT_PERMISSION);
        var advanced=!(ManageLayouts.hasLayoutPermission(ManageLayouts.EDIT_PERMISSION) && ManageLayouts.hasGlobalPermission(ManageLayouts.EDIT_ADVANCED));
        disableProp("view",advanced);
        disableProp("edit",advanced);
        disableProp("editpanel",advanced);
        disableProp("child",advanced);
        disableCheckbox("view.btn",advanced);
        disableCheckbox("edit.btn",advanced);
        disableCheckbox("editpanel.btn",advanced);
        disableCheckbox("child.btn",advanced);
    }

    function getProp(prop) {
        var inp=document.getElementById("permissionsTab."+prop);
        if (inp!=null) return inp.value;
        return null
    }
    function getCheckbox(prop) {
        var inp=document.getElementById("permissionsTab."+prop);
        if (inp!=null) return inp.checked;
    }
    function getSelect(prop) {
        var inp=document.getElementById("permissionsTab."+prop);
        if (inp!=null) return inp.options[inp.selectedIndex].value
        return null;
    }
    function updateSettings(layout) {
        layout.permissions.view = getProp("view").split(",");
        layout.permissions.edit = getProp("edit").split(",");
        layout.permissions.editpanel = getProp("editpanel").split(",");
        layout.permissions.child = getProp("child").split(",");
        return layout;
    }

    function selectGroups(target) {
        if (!(ManageLayouts.hasLayoutPermission(ManageLayouts.EDIT_PERMISSION) && ManageLayouts.hasGlobalPermission(ManageLayouts.EDIT_ADVANCED))) return alert("You do not have permission to edit layout permissions");
        var selected = {};
        var groups = getProp(target).split(",");
        var i=groups.length;
        while (-1<--i) selected[groups[i]]=true;
        GroupSelector.show({target:"permissionsTab."+target,multi:true,selected:selected,callback:updateGroups});
    }
    function mergeGroups(target,groups) {
        var tgt=getProp(target);
        var existing={};
        var i;
        var a;
        if (tgt!=null) {
            a=tgt.split(",");
            i=a.length;
            while (-1<--i) if (a[i]!="") existing[a[i]]=true;
        }
        i=groups.length;
        while (-1<--i)  if (groups[i]!="") existing[groups[i]]=true;
        a=[];
        for (i in existing) {
            a.push(i);
        }
        setProp(target,a.join(","));
    }
    function updateGroups(target,groups) {
        target=target.split(".")[1];
        setProp(target,groups.join(","));
        if (target=="edit") {
            mergeGroups("child",groups);
            mergeGroups("view",groups);
        } else if (target=="child") {
            mergeGroups("view",groups);
        }
        ManageLayouts.changed();
    }

    function clearValue(prop) {
        if ((ManageLayouts.hasLayoutPermission(ManageLayouts.EDIT_PERMISSION) && ManageLayouts.hasGlobalPermission(ManageLayouts.EDIT_ADVANCED))) {
            ManageLayouts.clearValue(prop);
        }
    }

//    var active=true;
//    function setActive(tabPanel, activeTab) {
//        active = (activeTab.id=="permissionsTab");
//        if (active) updateDisplay(ManageLayouts.getManagedLayout());
//    }
//    Ext.get("layoutmanager").borderLayout.getRegion("center").getTabs().addListener("tabchange",setActive);
    function layoutLoaded(managedLayout) {
//        if (active) updateDisplay(managedLayout);
        updateDisplay(managedLayout);
    }
    updateDisplay(ManageLayouts.getManagedLayout());

    return {updateSettings:updateSettings,
            updateDisplay:updateDisplay,
            selectGroups:selectGroups,
            clearValue:clearValue,
            layoutLoaded:layoutLoaded};
})();

