if (typeof(QuickPreviewTab)=="undefined") var QuickPreviewTab = (function () {
    var layout;
    var confColours={};
    var spacekey = null;
    if (document.location.href.indexOf("key")>-1) {
        var s=document.location.href.indexOf("key")+4;
        var e=document.location.href.indexOf("&",s);
        if (e<0) {
            e=document.location.href.length;
        }
        spacekey=document.location.href.substr(s,e-s);
    }

    function onGetBackgroundImage(panel) {
        return function(bgImage) {
            if (bgImage!=null) {
                panel.style.backgroundImage=bgImage;
            }
        }
    }
    function updatePanel(panelID) {
        if (layout==null) return;
        // takes the panel data from DWR and applies it to the layout editor panel
        var panel=document.getElementById("mini-"+panelID);
        if (panel==null) return alert("unable to locate panel : "+panelID);
        var i;
        var panelData = layout[panelID];
        for (i in panelData) if (panelData[i]=="inherit") delete panelData[i];
        for (i in panelData) switch (i) {
            case "backgroundImage":
                if (panelData[i]==null) {
                    panel.style[i]="";
                } else if (panelData[i].match("([^:]*:){0,1}[^\^]*^.*")) {
                    ManageLayouts.callDWR("getBackgroundImage",[panelData[i],onGetBackgroundImage(panel)]);
                } else {
                    panel.style[i]=panel.style[i]=panelData[i];
                }
                break;

            case "backgroundColor":
            case "borderColor":
            case "color":
                panel.style[i]=(confColours[panelData[i]]!=null) ? confColours[panelData[i]] : ((panelData[i]==null) ? "" : panelData[i]);
                break;

            case "visible":
                if (panelID!="leftSlider" && panelID!="rightSlider") {
                    Visibility.setVisibility("mini-"+panelID,panelData[i]);
                }
                if (panelID=="leftSidebar") {
                    Visibility.setVisibility("mini-leftSlider", panelData[i] && layout.leftSlider.visible);
                } else if (panelID=="rightSidebar") {
                    Visibility.setVisibility("mini-rightSlider", panelData[i] && layout.rightSlider.visible);
                }
                break;

            case "defer":
            case "content":
                // do nothing
                break;
            case "collapse":
                Visibility.setVisibility("mini-"+panelID, !panelData[i]);
                break;
            default:
                panel.style[i]=(panelData[i]==null) ? "" : panel.style[i]=panelData[i];
        }
    }

    function updateDisplay(managedLayout) {
        if (managedLayout==null) return;
        layout=managedLayout.layout;
        updatePanel("body");
        updatePanel("page");
        updatePanel("header");
        updatePanel("menu");
        updatePanel("navigation");
        updatePanel("title");
        updatePanel("content");
        updatePanel("leftSidebar");
        updatePanel("leftSlider");
        updatePanel("rightSidebar");
        updatePanel("rightSlider");
        updatePanel("footnotes");
        updatePanel("footer");
    }

    var active=true;
    function getManagedLayout() {
        if (typeof(ConfigureTheme)!="undefined") return ConfigureTheme.getManagedLayout();
        if (typeof(ManageLayouts)!="undefined") return ManageLayouts.getManagedLayout();
    }
    function setActive(tabPanel, activeTab) {
        active = (activeTab.id=="quickpreview");
        if (active) updateDisplay(getManagedLayout());
    }
    Ext.get("layoutselector").borderLayout.getRegion("center").getTabs().addListener("tabchange",setActive);
    function layoutLoaded(managedLayout) {
        layout=managedLayout.layout;
        if (active) updateDisplay(managedLayout);
    }

    function onGetConfColurs(colours) {
        confColours=colours;
        updateDisplay(getManagedLayout());
    }
    ManageLayouts.callDWR("getColourScheme",[spacekey,onGetConfColurs]);
    
    return {layoutLoaded:layoutLoaded};
})();