/*
 * Ext - JS Library 1.0 Alpha 2
 * Copyright(c) 2006-2007, Jack Slocum.
 *
 * http://www.extjs.com/license.txt
 */

Ext.data.DWRProxy = function(DWRinterface){
    Ext.data.DWRProxy.superclass.constructor.call(this);
    this.DWR = DWRinterface;
};

Ext.extend(Ext.data.DWRProxy, Ext.data.MemoryProxy, function () {
    function dwrCallback(params, reader, callback, scope, arg) {
        return function (data) {
            var result;
            try {
                result = reader.readRecords(data);
            }catch(e){
                this.fireEvent("loadexception", this, arg, null, e);
                callback.call(scope, null, arg, false);
                return;
            }
            callback.call(scope, result, arg, true);
        }
    }

    function load (params, reader, callback, scope, arg){
        params = params || {};
        var args=[];
        if (params.dwrArguments) args.concat(params.dwrArguments);
        args.push(dwrCallback(params, reader, callback, scope, arg));
        this.DWR[params.dwrMethod].apply(this.DWR, args);
    }

    return {load:load};
}());