(function() {
    /**
     * @class Ext.grid.ImageToggleEditor
     * @extends Ext.grid.ImageToggleEditor
    basically a checkbox for editing boolean values, but without the checkbox - displays one of two images instead.<br><br>
    For more information on using this editor, see <a href="http://www.jackslocum.com/yui/2006/09/10/adding-built-in-editing-support-to-the-yahoo-ui-extensions-grid/">this blog post</a>.
    * @constructor
    * Create a new ImageToggleEditor
     */
    Ext.grid.ImgToggleEditor = function(selectedImg,deselectedImg){
        this.selectedImg = (typeof(selectedImg)!="undefined") ? selectedImg : "bleh";
        this.deselectedImg = (typeof(deselectedImg)!="undefined") ? deselectedImg : "yarg";
        var div = document.createElement('span');
        div.className = 'ygrid-editor ygrid-imgtoggle-editor';
        var img = document.createElement('img');
        div.appendChild(img);
        document.body.appendChild(div);
        Ext.grid.ImgToggleEditor.superclass.constructor.call(this, div);
        div.tabIndex = '';
        this.img = Ext.get(img,true);
    };

    Ext.extend(Ext.grid.ImgToggleEditor, Ext.grid.CellEditor);

    var proto=Ext.grid.ImgToggleEditor.prototype;

    proto.setValue = function(value){
        this.img.dom.src = (this.selected = (value === true || value === 'true' || value === 1 || value === '1')) ? this.selectedImg : this.deselectedImg;
    };

    proto.getValue = function(){
         return this.selected===true;
    };

    proto.show = function(){
        this.setValue(!this.selected);
        this.stopEditing(true);
    };

    proto.hide = function(){
        this.element.hide();
    };
})();