if (typeof(AliasTab)=="undefined") var AliasTab = (function () {
    var pluginData;
    var aliasData;
    var locationData={};
    
    var type;

    function emptySelect(sel) {
        var i = sel.length;
        while (-1<--i) {
            sel.options[i]=null;
        }
    }

    function selectPlugin(key) {
        var plugin = pluginData[key];
        var moduleSelect = document.getElementById("module");
        emptySelect(moduleSelect);
        var moduleKey,module;
        for (moduleKey in plugin.modules) {
            module = plugin.modules[moduleKey];
            moduleSelect.options[moduleSelect.length] = new Option(module.name,module.key);
        }
    }

    function selectModule(key) {
    }

    function changeUrl() {
    }

    function setType(t) {
        type=t;
        var p = document.getElementById("pluginTd");
        var d = document.getElementById("urlTd");
        if (type=="plugin") {
            p.className = "enabled";
            d.className = "disabled";
            var inp = document.getElementById("url");
            inp.disabled = true;
            inp = document.getElementById("plugin");
            inp.disabled = false;
            inp = document.getElementById("module");
            inp.disabled = false;
        } else {
            p.className = "disabled";
            d.className = "enabled";
            var inp = document.getElementById("url");
            inp.disabled = false;
            inp = document.getElementById("plugin");
            inp.disabled = true;
            inp = document.getElementById("module");
            inp.disabled = true;
        }
    }

    function saveAlias() {
        var inp = document.getElementById("name");
        if (inp.value==null || inp.value.length==0) {
            return alert("The alias must have a name");
        }
        var alias={alias:inp.value,url:null,location:null,key:null,rel:null};
        inp = document.getElementById("rel");
        alias.rel=inp.value;
        if (type=='plugin') {
            inp = document.getElementById("plugin");
            var pData = pluginData[inp.options[inp.selectedIndex].value];
            if (typeof(pData)!="undefined") {
                inp = document.getElementById("module");
                var mData = pData.modules[inp.options[inp.selectedIndex].value];
                if (typeof(mData)!="undefined") {
                    alias.location = mData.location;
                    alias.key = mData.key;
                }
            }
        } else {
            inp = document.getElementById("url");
            alias.url = inp.value;
        }
        if ((alias.alias!=null && alias.alias.length>0) && ((alias.url!=null && alias.url.length>0) || (alias.location!=null && alias.location.length>0 && alias.key!=null && alias.key.length>0))) {
            ThemeAdminDWR.addAlias(alias,onSaveAlias(alias));
        } else {
            return alert("Invalid alias definition");
        }
    }

    function onSaveAlias(alias) {
        return function(state) {
            if (state) {
                aliasData[alias.alias]=alias;
                updateAliases();
            } else {
                alert("Failed to save alias");
            }
        }
    }

    function removeAlias(key) {
        var alias = aliasData[key];
        if (alias==null) {
            return alert("Invalid alias: "+key)
        }
        ThemeAdminDWR.removeAlias(alias.alias,onRemoveAlias(alias));
    }

    function onRemoveAlias(alias) {
        return function(state) {
            if (state) {
                aliasData[alias.alias]=null;
                updateAliases();
            } else {
                alert("Failed to remove alias");
            }
        }
    }

    function selectValue(inp, value) {
        var i = inp.length;
        while (-1<--i) {
            if (inp.options[i].value==value) {
                inp.selectedIndex=i;
                break;
            }
        }
    }

    function editAlias(key) {
        var alias = aliasData[key];
        if (alias==null) {
            return alert("Invalid alias: "+key)
        }
        var inp = document.getElementById("name");
        inp.value=alias.alias;
        inp = document.getElementById("rel");
        inp.value=alias.rel;
        if (alias.url!=null && alias.url.length!=0) {
            inp = document.getElementById("url");
            inp.value=alias.url;
            setType('url');
        } else {
            var lData = locationData[alias.location];
            if (lData!=null) {
                var mData = lData[alias.key];
                if (mData!=null) {
                    inp = document.getElementById("plugin");
                    selectValue(inp,mData.plugin);
                    selectPlugin(mData.plugin);
                    inp = document.getElementById("module");
                    selectValue(inp,mData.module);
                    inp = document.getElementById("url");
                    inp.value="";
                }
            }
            setType('plugin');
        }
    }

    function updateAliases() {
        var aliasKey,alias,html="";
        for (aliasKey in aliasData) {
            alias=aliasData[aliasKey];
            if (alias!=null) {
                html+="<tr><td>"+alias.alias+"</td><td>"+alias.location+"</td><td>"+alias.key+"</td><td>"+alias.url+"</td><td><a href=\"javascript:AliasTab.editAlias('"+alias.alias+"')\">edit</a> / <a href=\"javascript:AliasTab.removeAlias('"+alias.alias+"')\">remove</a></td></tr>";
            }
        }
        var aliasBody=document.getElementById("aliasBody");
        aliasBody.innerHTML=html;
    }


    function init(pData,aData) {
        pluginData = pData;
        aliasData = aData;

        updateAliases();

        var pluginKey,plugin,moduleKey,module;
        var pluginSelect = document.getElementById("plugin");
        emptySelect(pluginSelect);
        for (pluginKey in pluginData) {
            plugin = pluginData[pluginKey];
            pluginSelect.options[pluginSelect.length] = new Option(plugin.name,plugin.key);
            for (moduleKey in plugin.modules) {
                module = plugin.modules[moduleKey];
                if (locationData[module.location]==null) locationData[module.location]={};
                locationData[module.location][module.key]={plugin:plugin.key,  module:module.key};
            }
        }
        setType('plugin');
        selectPlugin(pluginSelect.options[pluginSelect.selectedIndex].value);
    }
    return {init:init,selectPlugin:selectPlugin,selectModule:selectModule,saveAlias:saveAlias,removeAlias:removeAlias,editAlias:editAlias,setType:setType};
})();