if (typeof(DefaultLayoutPanel)=="undefined") var DefaultLayoutPanel = (function () {
    var DEFAULT_LAYOUT_ID = "DEFAULT";
    var SPACEKEY_META_LAYOUT_ID = "@SPACEKEY@"
    var layout;
    var confColours={};
    function onGetConfColurs(colours) {
        confColours=colours;
        updateDisplay();
    }
    var spacekey = null;
    if (document.location.href.indexOf("key")>-1) {
        var s=document.location.href.indexOf("key")+4;
        var e=document.location.href.indexOf("&",s);
        if (e<0) {
            e=document.location.href.length;
        }
        spacekey=document.location.href.substr(s,e-s);
    }
    ManageLayoutsDWR.getColourScheme(spacekey,onGetConfColurs);

    // -------------------- standard input utility functions
    function disableProp(prop,value) {
        var inp=document.getElementById("defaultLayout."+prop);
        if (inp!=null) inp.readOnly=value;
    }
    function disableCheckbox(prop,value) {
        var inp=document.getElementById("defaultLayout."+prop);
        if (inp!=null) inp.disabled=value;
    }
    function disableSelect(prop,value) {
        var inp=document.getElementById("defaultLayout."+prop);
        if (inp!=null) inp.disabled=value;
    }

    function setDiv(prop,value) {
        var inp=document.getElementById("defaultLayout."+prop);
        if (inp!=null) inp.innerHTML=value;
    }
    function setProp(prop,value) {
        var inp=document.getElementById("defaultLayout."+prop);
        if (inp!=null) inp.value=value;
    }
    function setCheckbox(prop,value) {
        var inp=document.getElementById("defaultLayout."+prop);
        if (inp!=null) inp.checked=value;
    }
    function setSelect(prop,value) {
        var inp=document.getElementById("defaultLayout."+prop);
        if (inp!=null) {
            var i=inp.options.length;
            while (-1<--i) if ((""+inp.options[i].value)==value) inp.selectedIndex=i;
        }
    }

    function onGetBackgroundImage(panel) {
        return function(bgImage) {
            if (bgImage!=null) {
                panel.style.backgroundImage=bgImage;
            }
        }
    }
    function updatePanel(panelID) {
        if (layout==null) return
        // takes the panel data from DWR and applies it to the layout editor panel
        var panel=document.getElementById("mini-"+panelID);
        if (panel==null) return alert("unable to locate panel : "+panelID);
        var i;
        var panelData = layout[panelID];
        for (i in panelData) switch (i) {
            case "backgroundImage":
                if (panelData[i]==null) {
                    panel.style[i]="";
                } else if (panelData[i].match("([^:]*:){0,1}[^\^]*^.*")) {
                    ManageLayoutsDWR.getBackgroundImage(panelData[i],onGetBackgroundImage(panel));
                } else {
                    panel.style[i]=panel.style[i]=panelData[i];
                }
                break;

            case "backgroundColor":
            case "borderColor":
            case "color":
                panel.style[i]=(confColours[panelData[i]]!=null) ? confColours[panelData[i]] : ((panelData[i]==null) ? "" : panelData[i]);
                break;

            case "visible":
                Visibility.setVisibility("mini-"+panelID,panelData[i]);
                if (panelID=="leftSidebar") {
                    Visibility.setVisibility("mini-leftSlider", panelData[i] && layout.leftSlider.visible);
                } else if (panelID=="rightSidebar") {
                    Visibility.setVisibility("mini-rightSlider", panelData[i] && layout.rightSlider.visible);
                }
                break;

            case "defer":
            case "content":
                // do nothing
                break;
            case "collapse":
                Visibility.setVisibility("mini-"+panelID, !panelData[i]);
                break;
            default:
                panel.style[i]=(panelData[i]==null) ? "" : panel.style[i]=panelData[i];
        }
    }

    function updateDisplay() {
        updatePanel("body");
        updatePanel("page");
        updatePanel("header");
        updatePanel("menu");
        updatePanel("navigation");
        updatePanel("title");
        updatePanel("content");
        updatePanel("leftSidebar");
        updatePanel("leftSlider");
        updatePanel("rightSidebar");
        updatePanel("rightSlider");
        updatePanel("footnotes");
        updatePanel("footer");
    }


    function layoutLoaded(settings) {
        if (settings==null) return;
        layout=settings;
        setDiv("layoutId", settings.layoutId);
        setDiv("name", settings.name);
        setDiv("description", settings.description);
        if (settings.layoutId==SPACEKEY_META_LAYOUT_ID) {
            Visibility.setVisibility("mini-body",false);
        } else {
            Visibility.setVisibility("mini-body",true);
            updateDisplay();
        }
    }
    layoutLoaded(DefaultLayout.getThemeData());

    var defaults = DefaultLayout.getDefaultLayouts();
    updateGlobal(defaults["@GLOBAL@SPACE@TYPE@"]);
    updatePersonal(defaults["@PERSONAL@SPACE@TYPE@"]);

    function updateGlobal(layout) {
        setDiv("globalDefault",layout.layoutId);
        setDiv("globalDefault.name",layout.name);
        setDiv("globalDefault.description",layout.description);
        setCheckbox("globalDefault.locked",layout.locked);
    }

    function updatePersonal(layout) {
        setDiv("personalDefault",layout.layoutId);
        setDiv("personalDefault.name",layout.name);
        setDiv("personalDefault.description",layout.description);
        setCheckbox("personalDefault.locked",layout.locked);
    }

    return {layoutLoaded:layoutLoaded,
            updateGlobal:updateGlobal,
            updatePersonal:updatePersonal};
})();