if (typeof(DefaultLayout)=="undefined") var DefaultLayout = (function () {
    // -------------------- shared AO variables
    var DEFAULT_LAYOUT_ID = "DEFAULT";
    var SPACEKEY_META_LAYOUT_ID = "@SPACEKEY@"
    var defaultLayouts={};
    var selectedNodeID=DEFAULT_LAYOUT_ID;
    var previousNodeId=DEFAULT_LAYOUT_ID;
    var unsavedChanges=false;
    var themeData;// the currently selected theme's data
    var children;// the raw hierarchy data (list of each layout's children keyed by layout id)
    var layoutTree;// the nlstree object
    var layoutTreeDD;// the nlstreedd object
    var borderLayout;// the borderLayout object

    // -------------------- icon control
    var iconPath="/download/resources/com.adaptavist.confluence.themes.sitebuilder:sitebuilder/icons/";
    var iconStyles={readonly:["document_lock.png","document_lock.png"],
                    layout:["document.png","document.png"],
                    unsaved:["document_warning.png","document_warning.png"],
                    newlayout:["document_add.png","document_add.png"]};
    function getIcons(style) {
        if (iconStyles[style]!=null) return contextPath+iconPath+iconStyles[style][0]+","+contextPath+iconPath+iconStyles[style][1];
        return null;
    }


    // -------------------- tab loading
    function loadedTabContent(activeTab) {
        return function (tabcontent) {
            Visibility.removeClass(document.body,"waitCursor");
            Visibility.addClass(document.body,"normalCursor");
            activeTab.setContent(tabcontent,true);
        }
    }
    function loadTabContent(tabPanel, activeTab) {
        if (!activeTab.loaded) {
            activeTab.loaded=true;// dont really want to try and load it twice ;)
            Visibility.removeClass(document.body,"normalCursor");
            Visibility.addClass(document.body,"waitCursor");
            ThemeAdminDWR.getTab(activeTab.id,loadedTabContent(activeTab));
        }
    }

    // -------------------- layout loading
    function layoutLoaded(data) {
        unsavedChanges=false;
        Visibility.removeClass(document.body,"waitCursor");
        Visibility.addClass(document.body,"normalCursor");
        themeData=data.layout;
        layoutTree.selectNodeById(themeData.layoutId);
        previousNodeId=selectedNodeID;
        selectedNodeID=themeData.layoutId;
        if (typeof(DefaultLayoutPanel)!="undefined") DefaultLayoutPanel.layoutLoaded(themeData);
    }
    function loadLayout(e,treeNodeID) {
        if ("s_p_a_c_e_k_e_y"==treeNodeID) {
            layoutLoaded({viewPermission:true,editPermission:false,childPermission:false,layout:{layoutId:SPACEKEY_META_LAYOUT_ID,parentId:DEFAULT_LAYOUT_ID,name:"spacekey meta layout",description:"Use this as a default if you wish each space to have it's own distinct settings (Builder 2.x behaviour)"}});
        } else {
            Visibility.removeClass(document.body,"normalCursor");
            Visibility.addClass(document.body,"waitCursor");
            ManageLayoutsDWR.getLayout(treeNodeID,layoutLoaded);
        }
    }

    // -------------------- display initialisation
    function initBorderLayout() {
        if (borderLayout!=null) return;
        borderLayout = new Ext.BorderLayout("themeadmin-defaultlayout", {
            hideOnLayout: true,
            autoCreate: true,
            west: {
                split:true,
                initialSize: 150,
                minSize: 150,
                maxSize: 400,
                titlebar: true,
                collapsible: true,
                animate: true,
                autoCreate: true,
                autoScroll: true
            },
            center: {
                titlebar: false,
                tabPosition: 'top',
                autoCreate: true,
                autoScroll: true
            }
        });
        Ext.get("themeadmin-defaultlayout").borderLayout=borderLayout;
        // build the layout
        borderLayout.beginUpdate();
        borderLayout.add('west', new Ext.ContentPanel('themeadmin-defaultlayout-treepanel', {title: 'Choose layout...', autoScroll: true, autoCreate: true}));
        var cp = new Ext.ContentPanel('themeadmin-defaultlayout-panel', {title: 'Defaults', autoScroll: true, autoCreate: true});
        borderLayout.add('center', cp);
        borderLayout.endUpdate();
        // update the panels
        Ext.get("themeadmin-defaultlayout-treepanel").update("<div id='treeview' class='treeview'></div>");
        initTree();
        borderLayout.layout();
        ThemeAdminDWR.getTab("themeadmin-defaultlayout-panel",loadedTabContent(cp));
    }
    Ext.EventManager.onDocumentReady(initBorderLayout);


    // -------------------- tree initialisation
    function createBranch (layoutId, data) {
      var branch={};
      if (data[layoutId]!=null) {
        var o = data[layoutId].reverse();
        var i = o.length;
        while (-1<--i) {
          branch[o[i]] = createBranch(o[i],data);
        }
      }
      return branch;
    }
    function generateChildNodes(parentNodeId,childNodeData){
        var i;
        for (i in childNodeData) {
            layoutTree.add(i,parentNodeId,i,"",getIcons("layout"),true,false,{id:i},"description");
            generateChildNodes(i,childNodeData[i]);
        }
    }
    var onNodeDrop;
    function treeInit(data) {
        children=data;
        
        Visibility.removeClass(document.body,"waitCursor");
        Visibility.addClass(document.body,"normalCursor");
        layoutTree=new NlsTree("layoutTree");
        layoutTree.treeOnClick=loadLayout;
        layoutTree.add(DEFAULT_LAYOUT_ID, 0, DEFAULT_LAYOUT_ID, "", getIcons("readonly"), true, false, {id:DEFAULT_LAYOUT_ID}, "Default layout (read only)");
        layoutTree.add("s_p_a_c_e_k_e_y", DEFAULT_LAYOUT_ID, SPACEKEY_META_LAYOUT_ID, "", getIcons("readonly"), true, false, {id:SPACEKEY_META_LAYOUT_ID}, "Space meta layout");
        generateChildNodes(DEFAULT_LAYOUT_ID,createBranch(DEFAULT_LAYOUT_ID,data));
        layoutTree.render("treeview");
        loadLayout(null,DEFAULT_LAYOUT_ID);
    }
    var tree_timeout = 0;
    function initTree() {
        if (typeof(dwr.engine)!="undefined" && typeof(ManageLayoutsDWR)!="undefined" && typeof(NlsTree)!="undefined") {
            Visibility.removeClass(document.body,"normalCursor");
            Visibility.addClass(document.body,"waitCursor");
            ManageLayoutsDWR.getHierarchy(treeInit);
        } else {
            if (tree_timeout++ < 120) {
                setTimeout(initTree, 250);
            } else {
                alert("themeadmin-defaultlayout.js : failed tree initialisation - dwr.engine["+typeof(dwr.engine)+"] ManageLayoutsDWR["+typeof(ManageLayoutsDWR)+"] NlsTree["+typeof(NlsTree)+"] ");
            }
        }
    }

    function onSetDefault(status) {
        if (status!=null) alert(status);
    }
    function setGlobal() {
        ThemeAdminDWR.setGlobalDefaultLayout(themeData.layoutId,onSetDefault);
        defaultLayouts["GLOBAL"]={layoutId:themeData.layoutId, name:themeData.name, description:themeData.description, locked:defaultLayouts["GLOBAL"].locked}
        if (typeof(DefaultLayoutPanel!="undefined")) DefaultLayoutPanel.updateGlobal(defaultLayouts["GLOBAL"]);
    }

    function setPersonal() {
        ThemeAdminDWR.setPersonalDefaultLayout(themeData.layoutId,onSetDefault);
        defaultLayouts["PERSONAL"]={layoutId:themeData.layoutId, name:themeData.name, description:themeData.description, locked:defaultLayouts["PERSONAL"].locked}
        if (typeof(DefaultLayoutPanel!="undefined")) DefaultLayoutPanel.updatePersonal(defaultLayouts["PERSONAL"]);
    }

    function lockGlobal(state) {
        defaultLayouts["GLOBAL"].locked=state;
        ThemeAdminDWR.lockGlobalDefaultLayout(state,onSetDefault);
    }

    function lockPersonal(state) {
        defaultLayouts["PERSONAL"].locked=state;
        ThemeAdminDWR.lockPersonalDefaultLayout(state,onSetDefault);
    }

    function onLoadDefaults(defaults) {
        if (defaults==null) defaults={};
        if (defaults["GLOBAL"]==null) defaults["GLOBAL"]={layoutId:DEFAULT_LAYOUT_ID, name:"Default Layout", description:"Default Layout", locked:false};
        if (defaults["PERSONAL"]==null) defaults["PERSONAL"]={layoutId:DEFAULT_LAYOUT_ID, name:"Default Layout", description:"Default Layout", locked:false};
        defaultLayouts=defaults;
    }
    ThemeAdminDWR.getDefaults(onLoadDefaults);


    function showGlobal() {
        loadLayout({},defaultLayouts["GLOBAL"].layoutId)
    }
    function showPersonal() {
        loadLayout({},defaultLayouts["PERSONAL"].layoutId)
    }

    // -------------------- return 'public' api
    return {getThemeData:function(){return themeData;},
            getDefaultLayouts:function(){return defaultLayouts;},
            setGlobal:setGlobal,
            setPersonal:setPersonal,
            lockGlobal:lockGlobal,
            lockPersonal:lockPersonal,
            showGlobal:showGlobal,
            showPersonal:showPersonal};
})();