if (typeof(ManageSpaces)=="undefined") var ManageSpaces = (function () {
    var iconPath="/download/resources/com.adaptavist.confluence.themes.sitebuilder:sitebuilder/icons/";

    // transform select lists
    var fm = Ext.form;
    var themeSelect = new fm.ComboBox({
              transform:"themeSelect",
              triggerAction:"all",
              editable:false,
              lazyRender:true
      });
    var layoutSelect = new fm.ComboBox({
              transform:"layoutSelect",
              triggerAction:"all",
              editable:false,
              lazyRender:true
      })

    // comboRenderer
    function themeSelectRenderer(value, p, r) {
        var rec = themeSelect.findRecord(themeSelect.valueField, value);
        if(rec){
            return rec.data[themeSelect.displayField];
        }
        if(typeof value == "string" && value.length < 1){
            return " ";
        }
        return value;
    }

    function layoutSelectRenderer(value, p, r) {
        var rec = layoutSelect.findRecord(layoutSelect.valueField, value);
        if(rec){
            return rec.data[layoutSelect.displayField];
        }
        if(typeof value == "string" && value.length < 1){
            return " ";
        }
        return value;
    }

    function spaceSelectedRenderer(value,p,r) {

    }

    // column model
    var Ed = Ext.grid.GridEditor;
    var cm = new Ext.grid.ColumnModel([
      {header: "Selected", dataIndex:"selected",width: 80, editor: new Ed(new fm.Checkbox())},
      {header: "Key", dataIndex:"key", width: 80},
      {header: "Name", dataIndex:"name", width: 130, editor: new Ed(new fm.TextField({allowBlank: false}))},
      {header: "Type", dataIndex:"type", width: 50},
      {header: "Teams", dataIndex:"teams", width: 80},
      {header: "Theme", dataIndex:"themeId", width: 140, editor: new Ed(themeSelect), renderer:themeSelectRenderer},
      {header: "Layout", dataIndex:"layoutId", width: 140, editor: new Ed(layoutSelect), renderer:layoutSelectRenderer},
      {header: "Layout Lock", dataIndex:"layoutLock", width: 80, editor: new Ed(new fm.Checkbox())}
    ]);
    // by default columns are sortable
    cm.defaultSortable = true;

    // define data returned by DWR
    var SpaceConfig = Ext.data.Record.create([
                {name: "selected", type: "bool"},
                {name: "key", type: "string"},
                {name: "name", type: "string"},
                {name: "type", type: "string"},
                {name: "teams", type: "string"},
                {name: "themeId"},
                {name: "layoutId"},
                {name: "layoutLock", type: "bool"}
            ]);

    // define the data store
    var ds = new Ext.data.Store({
            proxy: new Ext.data.DWRProxy(ThemeAdminDWR),
            reader: new Ext.data.ObjectReader({},SpaceConfig)
    });

    // create the grid
    var grid = new Ext.grid.EditorGrid('themeadmin-managespaces', {
            ds:ds,
            cm:cm,
            selModel: new Ext.grid.RowSelectionModel(),
            enableColLock:true
        });

    // make the grid resizable, do before render for better performance
//    var rz = new Ext.Resizable('themeadmin-managespaces', {
//        wrap:true,
//        minWidth: 300,
//        minHeight:100,
//        pinned:true,
//        handles: 's,e,se',
//        transparent:true
//    });
//    rz.on('resize', grid.autoSize, grid);

    // add listeners
    function onSetValue (status) {
        if (status) alert(status);
    }
    function onGridEdit(e) {
        ThemeAdminDWR.setValue(e.record.get("key"),e.field,e.value,onSetValue);
    }
    grid.on("afteredit",onGridEdit);

    // render
    grid.render();

    // initialise screen
    function initGrid() {
        if (typeof(dwr.engine)!="undefined" && typeof(ThemeAdminDWR)!="undefined" ) {
            ds.load({params:{dwrMethod:"getSpaces"}})
        } else {
            setTimeout(initGrid, 250);
        }
    }
    Ext.EventManager.onDocumentReady(initGrid);

    function refilter() {
        var isGlobal = document.getElementById("themeadmin-isglobal").checked;
        var isPersonal = document.getElementById("themeadmin-ispersonal").checked;
        var teamStr = document.getElementById("themeadmin-teams").value;
        var teams;
        if (teamStr!=null & teamStr.length>0) {
            teams = teamStr.split(" ");
        } else {
            teams = [];
        }
        var allTeams = !document.getElementById("themeadmin-teams-anyall").checked;
        var titleStr = document.getElementById("themeadmin-title").value;
        var title;
        if (titleStr!=null & titleStr.length>0) {
            title = titleStr.split(" ");
        } else {
            title = [];
        }
        var allTitle = !document.getElementById("themeadmin-title-anyall").checked;
        ds.filterBy(function (record,id) {
            if (!isGlobal && record.data.type=="global") return record.data.selected = false;
            if (!isPersonal && record.data.type=="personal") return record.data.selected = false;
            if (teams.length>0) {
                var i = teams.length;
                var validTeam=allTeams;
                while (-1<--i) if (allTeams) {
                    validTeam=(validTeam && record.data.teams.join(",").indexOf(teams[i])>-1);
                } else {
                    validTeam=(validTeam || record.data.teams.join(",").indexOf(teams[i])>-1);
                }
                if (!validTeam) return record.data.selected = false;
            }
            if (title.length>0) {
                var i = title.length;
                var validTitle=allTitle;
                while (-1<--i) if (allTitle) {
                    validTitle=(validTitle && record.data.name.indexOf(title[i])>-1);
                } else {
                    validTitle=(validTitle || record.data.name.indexOf(title[i])>-1);
                }
                if (!validTitle) return record.data.selected = false;
            }
            return record.data.selected = true;
        });
    }

    var dest = document.getElementById("managespaces-themeId");
    if (dest!=null) {
        dest.options[dest.options.length] = new Option("No Change", "@nochange@");
        for (i in availableThemes) {
            dest.options[dest.options.length] = new Option(availableThemes[i], i);
        }
    }
    dest = document.getElementById("managespaces-layoutId");
    if (dest!=null) {
        dest.options[dest.options.length] = new Option("No Change", "@nochange@");
        for (i in availableLayouts) {
            dest.options[dest.options.length] = new Option(availableLayouts[i], i);
        }
    }

    function bulkUpdate() {
        var theme = document.getElementById("managespaces-themeId");
        var themeId = theme.options[theme.selectedIndex].value;
        var layout = document.getElementById("managespaces-layoutId");
        var layoutId = layout.options[layout.selectedIndex].value;
        var layoutL = document.getElementById("managespaces-layoutLock");
        var layoutLock = layoutL.options[layoutL.selectedIndex].value;
        ds.each(function (record,id) {
            if (record.data.selected) {
                if (themeId!="@nochange@") {
                    record.data.themeId = themeId;
                    ThemeAdminDWR.setValue(record.data.key,"themeId",themeId,onSetValue);
                }
                if (layoutId!="@nochange@") {
                    record.data.layoutId = layoutId;
                    ThemeAdminDWR.setValue(record.data.key,"layoutId",layoutId,onSetValue);
                }
                if (layoutLock!="@nochange@") {
                    record.data.layoutLock = layoutLock=="true";
                    ThemeAdminDWR.setValue(record.data.key,"layoutLock",layoutLock,onSetValue);
                }
            }
        });
        grid.render();
    }

    function selectAll() {
        ds.each(function (record,id) {
            record.data.selected = true;
        });
        grid.render();
    }

    function deselectAll() {
        ds.each(function (record,id) {
            record.data.selected = false;
        });
        grid.render();
    }

    // public interface
    return {refilter:refilter,bulkUpdate:bulkUpdate,selectAll:selectAll,deselectAll:deselectAll};
})();