if (typeof(ManagePermissions)=="undefined") var ManagePermissions = (function () {
    var MANAGE_LAYOUTS = "manageLayouts";
    var EDIT_ADVANCED = "editAdvanced";
    var EDIT_CSS = "editCSS";

    // -------------------- standard input utility functions
    function disableProp(prop,value) {
        var inp=document.getElementById("managePermissions."+prop);
        if (inp!=null) inp.readOnly=value;
    }
    function disableCheckbox(prop,value) {
        var inp=document.getElementById("managePermissions."+prop);
        if (inp!=null) inp.disabled=value;
    }
    function disableSelect(prop,value) {
        var inp=document.getElementById("managePermissions."+prop);
        if (inp!=null) inp.disabled=value;
    }

    function setDiv(prop,value) {
        var inp=document.getElementById("managePermissions."+prop);
        if (inp!=null) inp.innerHTML=value;
    }
    function setProp(prop,value) {
        var inp=document.getElementById("managePermissions."+prop);
        if (inp!=null) inp.value=value;
    }
    function setCheckbox(prop,value) {
        var inp=document.getElementById("managePermissions."+prop);
        if (inp!=null) inp.checked=value;
    }
    function setSelect(prop,value) {
        var inp=document.getElementById("managePermissions."+prop);
        if (inp!=null) {
            var i=inp.options.length;
            while (-1<--i) if ((""+inp.options[i].value)==value) inp.selectedIndex=i;
        }
    }
    function setPermission(prop,value) {
        if (value==null || value==undefined || value.length==0) {
            value = ["confluence-administrators"];
        }
        setProp(prop,value.join(","));
    }
    function onGetGlobalPermissions(data) {
        if (data==null) return;
        setPermission("manageLayouts", data[MANAGE_LAYOUTS]);
        setPermission("advanced", data[EDIT_ADVANCED]);
        setPermission("css", data[EDIT_CSS]);
    }
    ThemeAdminDWR.getGlobalPermissions(onGetGlobalPermissions);

    function getProp(prop) {
        var inp=document.getElementById("managePermissions."+prop);
        if (inp!=null) return inp.value;
        return null
    }
    function getCheckbox(prop) {
        var inp=document.getElementById("managePermissions."+prop);
        if (inp!=null) return inp.checked;
    }
    function getSelect(prop) {
        var inp=document.getElementById("managePermissions."+prop);
        if (inp!=null) return inp.options[inp.selectedIndex].value
        return null;
    }

    function selectGroups(target) {
        var selected = {};
        var groups = getProp(target).split(",");
        var i=groups.length;
        while (-1<--i) selected[groups[i]]=true;
        GroupSelector.show({target:"managePermissions."+target,multi:true,selected:selected,callback:updateGroups});
    }
    function mergeGroups(target,groups) {
        var tgt=getProp(target);
        var existing={};
        var i;
        var a;
        if (tgt!=null) {
            a=tgt.split(",");
            i=a.length;
            while (-1<--i) if (a[i]!="") existing[a[i]]=true;
        }
        i=groups.length;
        while (-1<--i)  if (groups[i]!="") existing[groups[i]]=true;
        a=[];
        for (i in existing) {
            a.push(i);
        }
        setProp(target,a.join(","));
    }
    function updateGroups(target,groups) {
        target=target.split(".")[1];
        setProp(target,groups.join(","));
        changed(target);
    }

    function onSetPermissions(status) {
        if (status!=null) alert(status);
    }
    function changed(target) {
        var groups = getProp(target).split(",");
        if (target=="css") {
            mergeGroups("manageLayouts",groups);
            ThemeAdminDWR.setGlobalPermission(EDIT_CSS,getProp("css").split(","),onSetPermissions);
        } else if (target=="advanced") {
            mergeGroups("manageLayouts",groups);
            ThemeAdminDWR.setGlobalPermission(EDIT_ADVANCED,getProp("advanced").split(","),onSetPermissions);
        }
        ThemeAdminDWR.setGlobalPermission(MANAGE_LAYOUTS,getProp("manageLayouts").split(","),onSetPermissions);
    }


    return {selectGroups:selectGroups,changed:changed};
})();

