if (typeof(Visibility)=="undefined") var Visibility = (function () {

    // NB: I've made the assumption that jQuery is always available
    // IMHO, no jQuery, no visibility stuff

    var visData = {};

    function loadVisData(id) {
       var current = jQuery.cookie('atb_vis');
       if (current != null) {
         current = current.split();
         jQuery.each(current,function(i,v) {
           i = v.split(':');
           visData[i[0]] = (i[1]=="1");
         });
       }
       return (id) ? visData[id] : null;
    }
    loadVisData();
    function saveVisData(id, state, store) {
      visData[id] = state;
      if (store) {
        var current = [];
        jQuery.each(visData,function(n,v) {
          v = (v) ? "1" : "0";
          current.push(n+":"+v);
        });
        jQuery.cookie('atb_vis',current.join(),{path:'/'});
      }
    }

    function setVisibility (id, state, store, speed) {
        if (!speed) speed = 600;
        if (state=null) state = jQuery("#"+id).is(":hidden"); // if it's not visible now, it soon will be!
        void (state) ? jQuery("#"+id).filter(":hidden").fadeIn(speed) : jQuery("#"+id).filter(":visible").fadeOut(speed);
        saveVisData(id,state,store);
        return state;
    }
    function toggleVisibility (id,store) {
        return setVisibility(id,null,store);
    }
    function restoreVisibility (id,def,store) {
        var v = visData[id];
        return setVisibility(id,(v==null) ? def : v,store,1);
    }
    function addClass(target,className) {
        jQuery(target).addClass(className);
    }
    function removeClass(target,className) {
        jQuery(target).removeClass(className);
    }
    function setState (id, state) {
        // NB: Do not use toggleClass() as it relies on classes being set correctly beforehand
        if (state) {
          jQuery('#'+id).addClass("expanded").removeClass("collapsed");
        } else {
          jQuery('#'+id).addClass("collapsed").removeClass("expanded");
        }
    }
    function toggleSidebar (id) {
        var state=setVisibility(id,null,true);
        setState(id,state);
        setState(id+"-slider",state);
    }
    function restoreSidebar (id,collapse) {
        var state=restoreVisibility(id,!collapse,true);
        setState(id,state);
        setState(id+"-slider",state);
    }
    return {setVisibility:setVisibility,
//            setVisibilityCookie:setVisibilityCookie,
            toggleVisibility:toggleVisibility,
            restoreVisibility:restoreVisibility,
            toggleSidebar:toggleSidebar,
            addClass:addClass,
            removeClass:removeClass,
            restoreSidebar:restoreSidebar};
})();

// deliberately defined outside to maintain compatibility with confluence.
function showBreadcrumbsEllipsis() {
    jQuery('#breadcrumbsEllipsis').hide();
    jQuery('#breadcrumbsExpansion').show(); // not sure if this will work, but worth a try
    //document.getElementById('breadcrumbsExpansion').style.display = 'inline';
}