
YAHOO.example.ColorPicker = function() {

    var Slider=YAHOO.widget.Slider;
    var Color=YAHOO.util.Color;
    var Dom=YAHOO.util.Dom;

    var pickerSize=180;

    var hue,picker,panel;

    // hue, int[0,359]
    function getH() {
        var h = (pickerSize - hue.getValue()) / pickerSize;
        h = Math.round(h*360);
        return (h == 360) ? 0 : h;
    }

    // saturation, int[0,1], left to right
    function getS () {
        return picker.getXValue() / pickerSize;
    }

    // value, int[0,1], top to bottom
    function getV () {
        return (pickerSize - picker.getYValue()) / pickerSize;
    }

    var hexvalue;
    function swatchUpdate () {
        var h=getH(), s=getS(), v=getV();
        YAHOO.log("hsv " + [h,s,v]);

        Dom.get("hval").value = h;
        Dom.get("sval").value = Math.round(s*100);
        Dom.get("vval").value = Math.round(v*100);

        var rgb = Color.hsv2rgb(h, s, v);

        var styleDef = "rgb(" + rgb.join(",") + ")";
        Dom.setStyle("swatch", "background-color", styleDef);

        Dom.get("rval").value = rgb[0];
        Dom.get("gval").value = rgb[1];
        Dom.get("bval").value = rgb[2];

        hexvalue = Color.rgb2hex(rgb[0], rgb[1], rgb[2]);
//        Dom.get("hexval").value = hexvalue;
        return hexvalue;
    };
    var currentcolour;
    function updateDialog() {
        if (typeof(ColourDialog)!="undefined" && hexvalue!=currentcolour) {
            ColourDialog.selectColour("#"+hexvalue,"ColorPicker");
            currentcolour=hexvalue;
        }
    }

    var timeoutId;
    var ignoreUpdate=false;
    function dialogUpdate() {
        if (ignoreUpdate) return;
        clearTimeout(timeoutId);
        timeoutId=setTimeout(updateDialog,444);
    }

    function hueUpdate (newOffset) {
        YAHOO.log("hue update: " + newOffset , "warn");
        var rgb = Color.hsv2rgb(getH(), 1, 1);
        var styleDef = "rgb(" + rgb.join(",") + ")";
        Dom.setStyle("pickerDiv", "background-color", styleDef);
        swatchUpdate()
        dialogUpdate();
    };

    function pickerUpdate (newOffset) {
        YAHOO.log("picker update [" + newOffset.x + ", " + newOffset.y + "]" , "warn");
        swatchUpdate()
        dialogUpdate();
    };


    function RGB2HSB(RGBstr){
        var red = parseInt(RGBstr.substr(1,2),16);
        var gre = parseInt(RGBstr.substr(3,2),16);
        var blu = parseInt(RGBstr.substr(5,2),16);
        if ((red==NaN) || (gre==NaN) || (blu==NaN)) return -1;
        var max = Math.max(red,Math.max(gre,blu));
        var min = Math.min(red,Math.min(gre,blu));
        var colHSB = {H:0,S:0,B:Math.round(max*100/255)};
        if(max!=min){
            colHSB.S = Math.round(100*(max-min)/max);
            var hue;
            var tmpR = (max-red)/(max-min);
            var tmpG = (max-gre)/(max-min);
            var tmpB = (max-blu)/(max-min);
            if(red==max){
                hue = tmpB - tmpG;
            }else if(gre==max){
                hue = 2 + tmpR - tmpB;
            }else if(blu==max){
                hue = 4 + tmpG - tmpR;
            }
            colHSB.H = (Math.round(hue*60) + 360)%360;
        }
        return colHSB;
    }

     function selectColour (hexvalue) {
        if (hexvalue!=null) {
            var hsv = RGB2HSB(hexvalue);
            ignoreUpdate=true;
            if (typeof(picker.baselinePos)!="undefined") picker.verifyOffset();
            picker.setRegionValue((hsv.S/100)*pickerSize,(1-(hsv.B/100))*pickerSize,true)
            hue.setValue((1-(hsv.H/360))*pickerSize,true);
            swatchUpdate();
            ignoreUpdate=false;
        }
    }

    function init () {
        hue = Slider.getVertSlider("hueBg", "hueThumb", 0, pickerSize);
        hue.subscribe("change", hueUpdate);

        picker = Slider.getSliderRegion("pickerDiv", "selector", 0, pickerSize, 0, pickerSize);
        picker.subscribe("change", pickerUpdate);

        if (typeof(ColourDialog)!="undefined") {
            selectColour(ColourDialog.getSelectedColourValue());
        }
    }

    return {init:init, selectColour:selectColour};
}();

function startup() {
    if (typeof(YAHOO.widget.Slider)=="undefined" || typeof(YAHOO.util.Dom)=="undefined" || typeof(YAHOO.util.Color)=="undefined") {
        setTimeout(startup,333);
    } else {
        YAHOO.example.ColorPicker.init();
    }
}
startup();
